<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;
use App\Models\ApiUser;
use DB;
use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Http;

class AuthController extends Controller
{
    // public function register(Request $request)
    // {
    //     $request->validate([
    //         'username' => [
    //             'required',
    //             'string',
    //             'max:255',
    //             Rule::unique('api_users', 'username'),
    //         ],
    //         'password' => 'required|string|min:8',
    //         'email' => 'nullable|email|unique:api_users,email',
    //     ]);

    //     $user = ApiUser::create([
    //         'username' => $request->input('username'),
    //         'password' => Hash::make($request->input('password')),
    //         'email' => $request->input('email'),
    //     ]);

    //     return response()->json(['message' => 'User registered successfully'], 201);
    // }

    public function login(Request $request)
    {
        $request->validate([
            'username' => 'required',
            'password' => 'required'
        ]);

        $user = ApiUser::where('username', $request->input('username'))->first();

        if (!$user || !Hash::check($request->input('password'), $user->password)) {
            return response()->json(['error' => 'Invalid credentials'], 401);
        }

        DB::table('oauth_access_tokens')->where('expires_at', '<', now()->addMinutes(60))->delete();
        $date = now()->addHour(12);
        $token = $user->createToken('authToken')->accessToken;

        return response()->json(['expires_at' => $date->format('Y-m-d H:i:s'),'token' => $token]);
    }
}
