<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Client extends Model
{
    use HasFactory;

    protected $table = 'clients';

    public $timestamps = false;

    protected $fillable = ['company_id', 'client_name', 'client_type_id', 'address_line1', 'address_line2', 'city', 'state_code', 'county_id', 'zip', 'logo', 'added_datetime', 'added_by', 'is_active'];


    public function companies()
    {
        return $this->belongsTo(Company::class, 'company_id', 'id');
    }

    public function clientTypes()
    {
        return $this->belongsTo(ClientType::class, 'client_type_id', 'id');
    }

    public function states()
    {
        return $this->belongsTo(State::class, 'state_code', 'id');
    }

    public function counties()
    {
        return $this->belongsTo(County::class, 'county_id', 'id');
    }

}

