<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Company extends Model
{
    use HasFactory;
	protected $table='companies';
    public $timestamps = false;

    protected $fillable = ['company_name','is_active'];

   public function clients()
    {
        return $this->hasMany(Client::class, 'company_id', 'id');
    }

    public function services()
    {
        return $this->hasMany(Service::class, 'id', 'id');
    }

    public function users()
    {
        return $this->hasMany(User::class, 'company_id', 'id');
    }

    public function states()
    {
        return $this->belongsTo(State::class, 'state', 'id');
    }

    public function counties()
    {
        return $this->belongsTo(County::class, 'county', 'id');
    }
}
