@extends('layouts.app')
@section('title', 'Lenders OMS | Assign')
@section('content')
<div class="container-fluid mt-2">
    @include('app.assignorders.index')
    <div class="col-lg-12">
        <div class="card ">
            <form action="{{route('assignment_update')}}" method="POST" enctype="multipart/form-data">
                @csrf
                <input type="hidden" name="type" value='1'>
            <div class="card-body">
                <div class="p-0">
                    <table id="datatable" class="table table-bordered nowrap" style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                        <thead>
                            <tr>
                                <th width="5%">Sl No</th>
                                <th>Order #</th>
                                <th>Client </th>
                                <th>Service </th>
                                <th>Borrower Name</th>
                                <th>Property Address</th>
                                <th>Status </th>
                                <th class="text-center">
                                    All <input type="checkbox" value="" id="selectall" name="selectall" class="pb-0 pt-3"/>
                                </th>
                                <td align="center" style="vertical-align: middle;">
                                    <select style="width: 150px;" required class="form-control form-control-sm" id="user_id" name="user_id" disabled>
                                         <option selected disabled value=""> Select User</option>
                                       {{-- @foreach ($users as $User)
                                        <option data-id="{{$User->service_ids}}" value="{{ $User->user_id }}">
                                            {!! ucwords($User->first_name." ".$User->last_name)  !!}
                                        </option>
                                        @endforeach --}}
                                    </select>
                                </td>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach($orders as $order)
                            @php
                                $inputData = json_decode($order->input, true);
                            @endphp
                                <tr style="color:#36374c">
                                    <td>{{ $loop->iteration}}</td>
                                    <td>{{ $order->id }}</td>
                                    <td>{!! isset($order->clients->client_name) ? $order->clients->client_name : "" !!}</td>
                                    <td data-id="{{$order->services->id}}">{!! isset($order->services->service_name) ? $order->services->service_name : "" !!}</td>
                                    <td>
                                        {!! isset($inputData['BorrowerInfo']['FirstBorrowerInfo']['first_name']) ? $inputData['BorrowerInfo']['FirstBorrowerInfo']['first_name'] : "" !!}
                                        {!! isset($inputData['BorrowerInfo']['FirstBorrowerInfo']['middle_name']) ? ' ' . $inputData['BorrowerInfo']['FirstBorrowerInfo']['middle_name'] : "" !!}
                                        {!! isset($inputData['BorrowerInfo']['FirstBorrowerInfo']['last_name']) ? ' ' . $inputData['BorrowerInfo']['FirstBorrowerInfo']['last_name'] : "" !!}
                                    </td>
                                    <td>{!! isset($inputData['PropertyData']['address']) ? $inputData['PropertyData']['address'] : "" !!}</td>
                                    <td>{!! isset($order->statusTypes->status) ? $order->statusTypes->status : "" !!}</td>
                                    <td align="center">
                                        <input  type="checkbox" value="{{$order->id}}" id="logs{{$order->id}}" name="orders[]" />
                                        {{-- <input type="checkbox" value="{{$order->id}}" id="logs{{$order->id}}" name="orders[]" class="order-checkbox" /> --}}
                                    </td>
                                    <td> </td>
                                </tr>
                            @endforeach
                        </tbody>
                    </table>
                </div>
            </div>
                <div class="form-group">
                    <div class="col-sm-12 text-center">
                        <button type="submit" class="btn btn-primary" style="display: none;" value="assign" id="assign" name="assign">Assign</button>
                    </div>
                </div>
            </form>
        </div>
    </div>
</div>

{{-- Js --}}
<script type="text/javascript">
 $(document).ready(function(){
        $("#selectall").on('change', function(){
            if($("input[type=checkbox]").hasClass("checkclass"))
                $("input[type=checkbox]").removeAttr("checked").removeClass('checkclass');
            else
                $("input[type=checkbox]").attr("checked", "checked").addClass('checkclass');
        });
    });

    $(function(){
        var requiredCheckboxes = $('.checkclass :checkbox[required]');
        requiredCheckboxes.change(function(){
            if(requiredCheckboxes.is(':checked')) {
                requiredCheckboxes.removeAttr('required');
            } else {
                requiredCheckboxes.attr('required', 'required');
            }
        });
    });

$(document).ready(function(){
    var selectedDataIds = [];

    function updateAssignStatus() {
        var anyCheckboxChecked = $('input[type="checkbox"]:checked').not('#selectall').length > 0;

        if (anyCheckboxChecked) {
            $('#user_id').prop('disabled', false);
            $('#assign').show();
        } else {
            $('#user_id').prop('disabled', true);
            $('#assign').hide();
        }
    }

    $('input[type="checkbox"]').change(function () {
        var rowId = $(this).val();
        var dataIdValue = $(this).closest('tr').find('td[data-id]').data('id');

        if ($(this).is(':checked')) {
            selectedDataIds[rowId] = dataIdValue;
        } else {
            delete selectedDataIds[rowId];
        }
        var serviceIds = Object.values(selectedDataIds).filter(value => value !== null);

        var serviceId = serviceIds.filter((value, index, self) => {
            return self.indexOf(value) === index;
        });


        $.ajax({
            url: "{{url('getServiceUsers')}}",
            type: "POST",
            data: {
                serviceId: serviceId,
                _token: '{{csrf_token()}}'
            },
            dataType: 'json',
            success: function (result) {
                $('#user_id').html('<option value="">Select User</option>');

                result.forEach(function(user) {
                    $('#user_id').append('<option value="' + user.id + '">' + user.first_name + ' ' + user.last_name + '</option>');
                });
            }
        });

        updateAssignStatus();
    });
});





</script>

@endsection
