@extends('layouts.app')
@section('title', 'Lenders OMS | Orders')
@section('content')

<style>
    .status-btn {
        font-size: .7rem !important;
    }
</style>

<div class="col-lg-12 mt-2">
    <div class="card">
        <div class="card-body">
            <div class="row mx-4 mt-2 mb-4" id="statusButtons">
                <div class="bg-info shadow-lg p-0 rounded text-white " style="text-decoration: none; font-size:0.7rem">
                    <button id="status_1"  class="btn btn-info status-btn">Order Received<span id="status_1_count"></span></button>
                    <button id="status_2"  class="btn btn-info status-btn">Open<span id="status_2_count"></span></button>
                    <button id="status_3" class="btn btn-info status-btn">In-Progress<span id="status_3_count"></span></button>
                    <button id="status_4" class="btn btn-info status-btn">Follow Up<span id="status_4_count"></span></button>
                    <button id="status_5" class="btn btn-info status-btn">Clarification Req<span id="status_5_count"></span></button>
                    <button id="status_6" class="btn btn-info status-btn">Clarification Rec<span id="status_6_count"></span></button>
                    <button id="status_7" class="btn btn-info status-btn">Qc Queue<span id="status_7_count"></span></button>
                    <button id="status_8" class="btn btn-info status-btn">Completed<span id="status_8_count"></span></button>
                    <button id="status_9" class="btn btn-info status-btn">Closed<span id="status_9_count"></span></button>
                    <button id="status_10" class="btn btn-info status-btn">Cancelled<span id="status_10_count"></span></button>
                    <button id="status_11" class="btn btn-info status-btn">Pending<span id="status_11_count"></span></button>
                    <button id="status_12" class="btn btn-info status-btn">On Hold<span id="status_12_count"></span></button>
                    <button id="status_All" class="btn btn-info status-btn @role('Lead') d-none  @endrole @role('User') d-none  @endrole" >All<span id="status_All_count"></span></button>
                </div>
            </div>
            <div class="p-0 mx-2">
                <table id="order_datatable" class="table table-bordered nowrap" style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                    <thead>
                        <tr>
                            {{-- <th width="5%">Sl No</th> --}}
                            <th>Client</th>
                            <th>Service</th>
                            <th>Assigned To</th>
                            <th>Status</th>
                            <th><span>Borrower</span> / <span style="color:orange">Vendor</span></th>
                            <th>Property Address</th>
                            <th>Created By</th>
                            <th width="5%">Order#</th>
                            <th>Order Received</th>
                            <th>Comments</th>
                        </tr>
                    </thead>
                    <tbody>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</div>
<script type="text/javascript">
        $(function () {
                @if(Session::has('success'))
                new PNotify({
                title: 'Success',
                delay: 500,
                text:  "{{Session::get('success')}}",
                type: 'success'
                });

                @endif
                @if ($errors->any())
                var err = "";
                @foreach ($errors->all() as $error)

                    new PNotify({
                    title: 'Error',
                    text: "{{$error}}",
                    delay: 800,
                    type: 'error'
                    });
                    @endforeach
                @endif
            });


            function serviceStatus(value) {
    window.location.href = '/serviceStatus/' + value;
    }

    let task_status = 1;
    let status_change;
    let first_load = 1;

    $(document).on('click', '.status-btn', function () {
        $('.status-btn').removeClass('btn-primary').addClass('text-white');
        $(this).removeClass('btn-info');
        $(this).addClass('btn-primary');
        status_change();
    });

    $(function () {
        status_change();
    });

    status_change = function () {
        let task_status = $('#statusButtons').find('.btn-primary').attr('id');
        let status = null;

        if (first_load === 1) {
            first_load = 2;
            @if(isset($begin))
            status = "{{$begin}}";
            @endif
            if (!status || status === undefined) {
                status = "1";
                $('.status-btn').removeClass('btn-primary').addClass('text-white');
                $('#status_' + status).removeClass('btn-info').addClass('btn-primary');
            } else {
                $('.status-btn').removeClass('btn-primary').addClass('text-white');
                $('#status_' + status).removeClass('btn-info').addClass('btn-primary');
            }
        } else {
            status = task_status.replace("status_", "");
        }

        var statusColumnVisible = (status === 'All') ? true : false;
        console.log(status);
        var otherinfo = ["4", "5", "6", "10", "11", "12"].includes(status) ? true : false;

        $.ajax({
        url: "{{url('getOrderData')}}",
        type: "POST",
        data: {
            status: status,
            _token: '{{csrf_token()}}'
        },
        dataType: 'json',
        success: function (response) {
            var OrderData = response.OrderData;
            updateStatusCounts(response.StatusCounts);
            var table = $('#order_datatable').DataTable();
            table.destroy();
            var table = $('#order_datatable').DataTable({
                data: OrderData,
                lengthMenu: [10, 50, 100, 200, 500],
                columns: [
                    // { data: null, render: function (data, type, row, meta) { return meta.row + 1; } },
                    {
                            data: null,
                            render: function (data, type, row) {
                                if(row.clients != null && row.clients != undefined) {
                                    return row.clients.client_name;
                                } else {
                                    return '';
                                }
                            }
                        },
                        {
                            data: null,
                            render: function (data, type, row) {
                                if(row.services != null && row.services != undefined) {
                                    return row.services.service_name;
                                } else {
                                    return '';
                                }
                            }
                        },
                    {
                        data: null,
                        render: function (data, type, row) {
                            return (row.assigned_users != null && row.assigned_users != undefined) ?
                                (row.assigned_users.first_name + ' ' + row.assigned_users.last_name) : '';
                        }
                    },
                    {
                            data: null,
                            visible: statusColumnVisible,
                            render: function (data, type, row) {
                                return (row.status_types.status != null && row.status_types.status != undefined) ? row.status_types.status : '';
                            }
                        },
                    {
                        data: null,
                        render: function (data, type, row) {
                            var firstBorrower = JSON.parse(row.input).BorrowerInfo.FirstBorrowerInfo;
                            if(firstBorrower.vendor_name != null && firstBorrower.vendor_name != "") {
                                return '<span style="color: orange;">' + firstBorrower.vendor_name + '</span>';
                            } else {
                                return (firstBorrower) ?
                                    (firstBorrower.first_name || '') +
                                    ' ' + (firstBorrower.middle_name || '') +
                                    ' ' + (firstBorrower.last_name || '') : '';
                            }
                        }
                    },
                    {
                        data: null,
                        render: function (data, type, row) {
                            var propertyData = JSON.parse(row.input).PropertyData;
                            var propertyData = (propertyData && propertyData.address) ? propertyData.address : '';
                            return '<div class="text-wrap">' + propertyData + '</div>';
                        }
                    },
                    {
                        data: 'created_by',
                        render: function (data, type, row) {
                            if (data && data.id !== null && data.id !== undefined) {
                                return data.first_name + ' ' + data.last_name;
                            } else {
                                return 'API Order';
                            }
                        }
                    },
                    { data: 'id', render: function (data) {
                         return '<a class="d-flex justify-content-center text-center assign-order bg-primary" style="cursor: pointer; padding: 2px;border-radius: 5px; color:white; " data-order-id="' + data + '" href="#" title="Edit"><strong>' + data + '</strong></a>';
                        }
                    },
                    {
                        data: 'created_at',
                        render: function (data, type, row) {
                            return (type === 'display' || type === 'filter') ? moment(data).format('MM/DD/YYYY hh:mm A') : data;
                        }
                    },
                    {
                        data: 'order_status_history',
                        visible: otherinfo,
                        render: function (data, type, row) {
                            var lastHistory = row.order_status_history[row.order_status_history.length - 1];
                            var content = (lastHistory && lastHistory.status_id != null &&
                                        [4, 5, 6, 10, 11, 12].includes(lastHistory.status_id) &&
                                        lastHistory.comments) ? lastHistory.comments : '';
                            return '<div class="text-wrap">' + content + '</div>';
                        }
                    },
                ],
                order: [8, 'desc']
            });

            updateStatusCounts(response.StatusCounts);
        }
    });


    };


    function updateStatusCounts(statusCounts) {
        let total = 0;

        for (let status = 1; status <= 12; status++) {
            let count = statusCounts[status] || 0;
            total += count;
            $('#status_' + status + '_count').text(' (' + count + ')');
        }

        // Update the count for the "All" button
        $('#status_All_count').text(' (' + total + ')');
    }

    // assign order
    $(document).on('click', '.assign-order', function (e) {
    e.preventDefault();

    var orderId = $(this).data('order-id');

    $.ajax({
        url: '/assignOrder',
        type: 'POST',
        data: {
            orderId: orderId,
            _token: '{{ csrf_token() }}'
        },
        dataType: 'json',
        success: function (response) {
            if (response.error) {
                console.error('Error assigning order: ' + response.error);
            } else {
                if (response.message === 'Order assigned successfully') {
                    window.location.href = '/orders/' + orderId;
                } else {
                    // alert('Unable to assign order: ' + response.message);
                    window.location.href = '/orders/' + orderId;
                }
            }
        },
        error: function (xhr, textStatus, errorThrown) {
            console.error('Error assigning order: ' + errorThrown);
        }
    });
    });


</script>
@endsection
