@extends('layouts.app')
@section('title', 'Lenders OMS | Orders Delete')
@section('content')
<div class="container-fluid mt-2">
    @include('app.settings.index')
    <div class="col-lg-12 ">
        <div class="card ">
            <form method="post" enctype="multipart/form-data">
                @csrf
            <div class="card-body">
                <div class="p-0">
                    <table id="datatable" class="table table-bordered nowrap" style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                        <thead>
                            <tr>
                                <th width="5%">Sl No</th>
                                <th>Order #</th>
                                <th>Client </th>
                                <th>Service </th>
                                <th>Borrower Name</th>
                                <th>Property Address</th>
                                <th>Status </th>
                                <th> Active / Inactive </th>
                                <th class="text-center">
                                    All <input type="checkbox" value="" id="selectall" name="selectall" class="pb-0 pt-3"/>
                                </th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach($orders as $order)
                            @php
                                $inputData = json_decode($order->input, true);
                            @endphp
                                <tr style="color:#36374c">
                                    <td>{{ $loop->iteration}}</td>
                                    <td>{{ $order->id }}</td>
                                    <td>{!! isset($order->clients->client_name) ? $order->clients->client_name : "" !!}</td>
                                    <td>{!! isset($order->services->service_name) ? $order->services->service_name : "" !!}</td>
                                    <td>
                                        {!! isset($inputData['BorrowerInfo']['FirstBorrowerInfo']['first_name']) ? $inputData['BorrowerInfo']['FirstBorrowerInfo']['first_name'] : "" !!}
                                        {!! isset($inputData['BorrowerInfo']['FirstBorrowerInfo']['middle_name']) ? ' ' . $inputData['BorrowerInfo']['FirstBorrowerInfo']['middle_name'] : "" !!}
                                        {!! isset($inputData['BorrowerInfo']['FirstBorrowerInfo']['last_name']) ? ' ' . $inputData['BorrowerInfo']['FirstBorrowerInfo']['last_name'] : "" !!}
                                    </td>
                                    <td>{!! isset($inputData['PropertyData']['address']) ? $inputData['PropertyData']['address'] : "" !!}</td>
                                    <td>{!! isset($order->statusTypes->status) ? $order->statusTypes->status : "" !!}</td>
                                    <td>{!! $order->is_active ? 'Active' : 'Inactive' !!}</td>
                                    <td align="center">
                                        <input  type="checkbox" value="{{$order->id}}" id="logs{{$order->id}}" name="orders[]" />
                                    </td>
                                </tr>
                            @endforeach
                        </tbody>
                    </table>
                </div>
            </div>
                <div class="form-group">
                    <div class="col-sm-12 text-center">
                        <button type="submit" id="deleteOrderBtn" class="btn btn-primary" value="delete_order" name="delete_order" onclick="updateOrderStatus(0)">Delete</button>
                        <button type="submit" id="undeleteOrderBtn" class="btn btn-danger" value="delete_order" name="delete_order" onclick="updateOrderStatus(1)">Undelete</button>
                    </div>
                </div>
            </form>
        </div>
    </div>
</div>
@endsection
@push('script-bottom')

{{-- Js --}}
<script type="text/javascript">
    $(document).ready(function(){
            $("#selectall").on('change', function(){
                if($("input[type=checkbox]").hasClass("checkclass"))
                    $("input[type=checkbox]").removeAttr("checked").removeClass('checkclass');
                else
                    $("input[type=checkbox]").attr("checked", "checked").addClass('checkclass');
            });
        });

        $(function(){
            var requiredCheckboxes = $('.checkclass :checkbox[required]');
            requiredCheckboxes.change(function(){
                if(requiredCheckboxes.is(':checked')) {
                    requiredCheckboxes.removeAttr('required');
                } else {
                    requiredCheckboxes.attr('required', 'required');
                }
            });
        });



    function updateOrderStatus(is_active) {
        $.ajax({
            type: "POST",
            url: "{{ route('update_order_status') }}", // Replace with your route
            data: {
                _token: '{{ csrf_token() }}',
                orders: getSelectedOrderIds(),
                is_active: is_active
            },
            success: function (response) {
                new PNotify({
						title: 'Success',
						text:  response.message,
						type: 'success'
					});
					setTimeout(function(){  location.reload(); }, 500);
            },
            error: function (error) {
                // Handle error response
                console.error(error);
            }
        });
    }

    function getSelectedOrderIds() {
        // Find all checked checkboxes with name "orders[]"
        return $('input[name="orders[]"]:checked').map(function () {
            return this.value;
        }).get();
    }



</script>
@endpush
