<?php $__env->startSection('title', 'Property DB | State'); ?>
<?php $__env->startSection('content'); ?>
<div class="container-fluid mt-2">
    <?php echo $__env->make('app.settings.index', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>
    <div class="col-lg-12">
        <div class="card ">
            <div class="card-body">
                <div class="p-0">
                    <table id="datatable" class="table table-bordered nowrap" style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                        <thead>
                            <tr>
                                <th style="width:10%" class="text-center">Sl No</th>
                                <th style="width:40%" class="text-center">State Name</th>
                                <th style="width:20%" class="text-center">State Code</th>
                                <th style="width:20%" class="text-center">Status</th>
                            </tr>
                        </thead>
                        <tbody>
                            <?php $__currentLoopData = $stateList; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $state): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                            <tr>
                                <td><?php echo e($loop->iteration); ?></td>
                                <td class="text-center"><?php echo e($state->state_name); ?></td>
                                <td class="text-center"><?php echo e($state->short_code); ?></td>
                                <td class="text-center">
                                    <div class="custom-control custom-switch">
                                        <input type="checkbox"  class="custom-control-input" id="customSwitch<?php echo e($state->id); ?>"  value="<?php echo e($state->id); ?>" <?php if(\Spatie\Permission\PermissionServiceProvider::bladeMethodWrapper('hasRole', 'Super Admin')): ?> onclick="stateStatus(this.value)" <?php endif; ?> <?php if($state->is_active==1): ?> checked <?php endif; ?>>
                                        <label class="custom-control-label" for="customSwitch<?php echo e($state->id); ?>"><?php if($state->is_active==1): ?> Active <?php else: ?> Inactive <?php endif; ?></label>
                                    </div>
                                </td>
                            </tr>
                            <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>

<script>
    function stateStatus(value) {
        var url = '/stateStatus/' + value;
        var data = {};
        var csrfToken = "<?php echo e(csrf_token()); ?>";

        $.ajax({
        type: 'POST',
        url: url,
        data: data,
        headers: {
            'X-CSRF-Token': csrfToken
        },
        success: function(response) {
            if(response.message == "Status Changed Successfully!") {
                new PNotify({
                    title: 'Success',
                    delay: 500,
                    text:  "Status Changed Successfully!",
                    type: 'success'
                });
            } else {
                new PNotify({
                    title: 'Error',
                    text: "An issue has arisen during the update",
                    delay: 800,
                    type: 'error'
                });
            }
        },
        error: function(error) {
            new PNotify({
                title: 'Error',
                text: "An issue has arisen during the update",
                delay: 800,
                type: 'error'
            });
        }
        });
    }
</script>
<?php $__env->stopSection(); ?>

<?php echo $__env->make('layouts.app', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH D:\Audit_master\Plant-Audit-Connect\resources\views/app/settings/state.blade.php ENDPATH**/ ?>