<?php $__env->startSection('title', 'Property DB | Conflicted Data'); ?>
<?php $__env->startSection('content'); ?>
<style>
    #datatable.dataTable {
        border-collapse: collapse !important;
    }

    tr {
        height: 10px;
    }

    @-webkit-keyframes spin {
        0% { -webkit-transform: rotate(0deg); }
        100% { -webkit-transform: rotate(360deg); }
    }

    .btn-danger {
        background-color: #DC3545 !important;
    }

    @keyframes spin {
        0% { transform: rotate(0deg); }
        100% { transform: rotate(360deg); }
    }

    #loading-overlay {
        position: fixed;
        width: 100%;
        height:100%;
        left: 0;
        top: 0;
        display: none;
        align-items: center;
        background-color: #000;
        z-index: 999;
        opacity: 0.5;
    }
    .loading-icon{ position:absolute;border-top:2px solid #fff;border-right:2px solid #fff;border-bottom:2px solid #fff;border-left:2px solid #767676;border-radius:25px;width:25px;height:25px;margin:0 auto;position:absolute;left:50%;margin-left:-20px;top:50%;margin-top:-20px;z-index:4;-webkit-animation:spin 1s linear infinite;-moz-animation:spin 1s linear infinite;animation:spin 1s linear infinite;}
    @-moz-keyframes spin { 100% { -moz-transform: rotate(360deg); } }
    @-webkit-keyframes spin { 100% { -webkit-transform: rotate(360deg); } }
    @keyframes spin { 100% { -webkit-transform: rotate(360deg); transform:rotate(360deg); } }

</style>
<div class="page-wrap">
    <!-- Page Content-->

    <div class="page-content pr-5 pl-5">
        <div class="container-fluid mt-2">
            <div class="row">
                <div class="col-lg-12">
                    <div class="card">
                        <div class="card-body">
                            <div class="row">
                                <div class="row col-lg-12 mb-2 mt-1 mb-0 pb-0">
                                    <div class="col-lg-2">
                                        
                                        <select required id="state" name="state" class="form-control" autocomplete="off">
                                        <option selected disabled value="">Select State</option>
                                        <?php $__currentLoopData = $stateList; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $state): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                                            <?php if(Session::get('state') == $state->id): ?>
                                                <option selected value="<?php echo e($state->id); ?>"><?php echo e($state->short_code); ?></option>
                                            <?php else: ?>
                                                <option value="<?php echo e($state->id); ?>"><?php echo e($state->short_code); ?></option>
                                            <?php endif; ?>
                                        <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                                        </select>
                                    </div>

                                    <div class="col-lg-2">
                                        
                                            <select required id="county" name="county" type="text" class="form-control" autocomplete="off" placeholder="Enter County"  data-parsley-trigger="focusout" data-parsley-trigger="keyup">
                                                <?php if(Session::has('county')): ?>
                                                <?php $__currentLoopData = $countyList; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $county): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                                                    <?php if(Session::get('county') == $county->id): ?>
                                                        <option selected value="<?php echo e($county->id); ?>"><?php echo e(Session::get('county_name')); ?></option>
                                                    <?php else: ?>
                                                        <option value="<?php echo e($county->id); ?>"><?php echo e($county->county_name); ?></option>
                                                    <?php endif; ?>
                                                <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>

                                                <?php endif; ?>
                                            </select>
                                    </div>
                                    <div class="col-lg-1">
                                        <button type="submit" id="update-button" class="btn btn-sm btn-primary" onclick="StateCountyUpdate();">Update</button>
                                    </div>
                                </div>
                                <div class="p-4 table-responsive">
                                    <div class="card-body" style="border-top:3px solid #7680ff">
                                    <?php if(count($errorDatas) > 0): ?>
                                        <div class="mt-2"><span style="font-size:10px"><strong>Note:</strong> Following Plats doesn't have Mapping Information in our Database, but showing status as VAC and PARVAC. By Clicking on <strong>Revert Conflicted Mappings</strong>, We will delete PARVAC entries and convert VAC status again to default PLAT.</span></div>
                                    <?php endif; ?>
                                    <table id="myTable" class="table table-bordered nowrap"
                                        style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                                        <thead>
                                            <tr>
                                                <th>Sub-Name</th>
                                                <th>Block</th>
                                                <th>Lot</th>
                                                <th>APN #</th>
                                                <th>Date</th>
                                                <th>Comments</th>
                                                <th class="text-center">Vac Type</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            <?php $__currentLoopData = $errorDatas; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $data): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                                            <tr style="color:#36374c">
                                                
                                                <td><?php echo e($data->subdivisions->subdivision_name); ?></td>
                                                <td><?php echo e($data->block); ?></td>
                                                <td><?php echo e($data->lot); ?></td>
                                                <td><?php echo e($data->apn_no); ?></td>
                                                <td><?php echo e($data->date !== null ? date("m/d/Y", strtotime($data->date)) : ''); ?></td>
                                                <td><?php echo e($data->comments); ?></td>
                                                <td><?php echo e($data->plat_types->type); ?></td>
                                            </tr>
                                            <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                                        </tbody>
                                    </table>
                                </div>
                                <div class="text-center mt-3">
                                    <button type="button" class="btn btn-danger mx-2" id="addToUnderlyingBtn" onclick="revert_changes(<?php echo e(Session::get('county')); ?>)">Revert Conflicted Mappings</button>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>


<script type="text/javascript">

    $(document).ready(function () {
        $('#myTable').DataTable({
            responsive: true,
            ordering: false,
            "paging": false,
            "searching": false,
        });
        userRole = "<?php echo Session::get('user_type_id'); ?>";
    });

    $(function () {
        <?php if(Session::has('success')): ?>
        new PNotify({
            title: 'Success',
            delay: 500,
            text: "<?php echo e(Session::get('success')); ?>",
            type: 'success'
        });

        <?php endif; ?>
        <?php if($errors -> any()): ?>
        var err = "";
        <?php $__currentLoopData = $errors -> all(); $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $error): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>

        new PNotify({
            title: 'Error',
            text: "<?php echo e($error); ?>",
            delay: 800,
            type: 'error'
        });
        <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
        <?php endif; ?>
    });

    // Initially, hide the "Update" button
    $("#update-button").hide();

    // When the state select changes
    $("#state").change(function() {
        $("#update-button").hide();
    });

    // When the county select changes
    $("#county").change(function() {
        // Check if a county is selected
        if ($(this).val() !== "Select County") {
            // Hide the "Update" button if county is selected
            $("#update-button").show();
        } else {
            $("#update-button").hide();
        }
    });

    function StateCountyUpdate() {
        var selectedState = $("#state").val();
        var selectedCounty = $("#county").val();
        var csrfToken = "<?php echo e(csrf_token()); ?>";

        $.ajax({
            type: 'POST',
            url: "<?php echo e(route('StateCountyUpdate')); ?>",
            data: {
                _token: csrfToken,
                state: selectedState,
                county: selectedCounty
            },
            dataType: 'json',
            success: function (response) {
                if (response.msg == "State and County Updated Successfully!") {
                    new PNotify({
                        title: 'Success',
                        text: response.msg,
                        type: 'success'
                    });
                    setTimeout(function () {
                        location.reload();
                    }, 500);
                    $("#update-button").hide();
                }
            },
            error: function (error) {
                new PNotify({
                    title: 'Error',
                    text: "State and County Updation failed!",
                    type: 'error'
                });
            }
        });
    }

    $('#state').on('change', function () {
        // $("#county").select2();
        var state_id = $("#state").val();
        $("#county").html('');
        $.ajax({
            url: "<?php echo e(route('getCounty')); ?>",
            type: "POST",
            data: {
                state_id: state_id,
                _token: '<?php echo e(csrf_token()); ?>'
            },
            dataType: 'json',
            success: function (result) {
                $('#county').html('<option value="">Select County</option>');
                $.each(result.counties, function (key, value) {
                    $("#county").append('<option value="' + value
                        .id + '">' + value.county_name + '</option>');
                });
            }
        });
    });

    function revert_changes(countyId) {
        Swal.fire({
            title: 'Are you sure?',
            text: 'You are about to delete all conflicted data at once!',
            icon: 'warning',
            showCancelButton: true,
            confirmButtonText: 'Yes, delete it!',
            cancelButtonText: 'No, cancel',
        }).then((result) => {
            if (result.value) {
                $.ajax({
                    type: 'POST',
                    url: "<?php echo e(route('delete_Conflicted_Mappings')); ?>",
                    data: {
                        _token: "<?php echo e(csrf_token()); ?>",
                        countyId: countyId
                    },
                    dataType: 'json',
                    success: function (response) {
                        if (response.msg == "Conflicted Data reverted successfully") {
                            new PNotify({
                                title: 'Success',
                                text: response.msg,
                                type: 'success'
                            });
                            setTimeout(function () {
                                location.reload();
                            }, 800);
                            $("#update-button").hide();
                        }
                    },
                    error: function (error) {
                        new PNotify({
                            title: 'Error',
                            text: "Can't revert data back!",
                            type: 'error'
                        });
                    }
                });
            }
        });
    }


</script>
<?php $__env->stopSection(); ?>

<?php echo $__env->make('layouts.app', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH D:\Audit_master\Plant-Audit-Connect\resources\views/app/subdivision/conflicted.blade.php ENDPATH**/ ?>