<?php $__env->startSection('title', 'Property DB | Subdivide Combine'); ?>
<?php $__env->startSection('content'); ?>

<style>
    /* Custom CSS for label and span alignment */
    .custom-label {
      width: 30%;
      display: inline-block;
      text-align: right;
      margin-right: 10px; /* Add spacing between label and span */
    }

    .btn-danger {
        background-color: rgba(255, 0, 0, 0.733) !important;
    }

    .custom-span {
      width: 60%;
      display: inline-block;
      vertical-align: middle;
    }

    .form-group {
        margin-bottom: 0; /* Set margin-bottom to 0 to remove the default spacing */
    }

    .history-table tbody tr td:first-child {
        width: 40%;
        font-weight: bold;
    }
/* Apply styles to the entire table */
/* Apply styles to the entire table */
.history-table {
    margin: 10px;
    /* display: inline-block; */
    border-collapse: collapse;
    border-spacing: 0;
    background-color: #fff; /* Background color for the entire table */
    box-shadow: 0 4px 6px rgba(0, 0, 0, 0.1); /* Add a subtle shadow to the table */
    transition: background-color 0.3s ease, transform 0.2s ease; /* Transition for background color and transform */
}

/* Style the table header */
.history-table tbody tr th {
    background-color: #6c63ff;
    color: #fff;
    padding: 10px;
    text-align: left;
    border-bottom: 2px solid #555;
    font-weight: bold;
    font-family: 'Franklin Gothic Medium', 'Arial Narrow', Arial, sans-serif;
    font-size: 14px;
}


/* Style table cells */
.history-table td {
    padding: 10px;
    border: 1px solid #e2e8f0;
}

/* Add hover effect to the entire table */
.history-table:hover {
    background-color: #fff563c2; /* Background color on hover */
    transform: scale(1.02); /* Scale up the table on hover */
    cursor: pointer; /* Change cursor on hover */
    font-weight: bold;
}
</style>

<div class="page-wrap">
    <!-- Page Content-->
    <div class="page-content pr-5 pl-5">
        <div class="container-fluid mt-2">
            <div class="row">
                <div class="col-lg-12">
                    <div class="card">
                        <div class="card-body">
                            <div class="row">
                                <div class="row col-lg-12 mb-2 mt-1 mb-0 pb-0">
                                    <div class="col-lg-2">
                                        <select required id="state" name="state" class="form-control mx-2" autocomplete="off">
                                        <option selected disabled value="">Select State</option>
                                        <?php $__currentLoopData = $stateList; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $state): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                                            <?php if(Session::get('state') == $state->id): ?>
                                                <option selected value="<?php echo e($state->id); ?>"><?php echo e($state->short_code); ?></option>
                                            <?php else: ?>
                                                <option value="<?php echo e($state->id); ?>"><?php echo e($state->short_code); ?></option>
                                            <?php endif; ?>
                                        <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                                        </select>
                                    </div>

                                    <div class="col-lg-2">
                                            <select required id="county" name="county" type="text" class="form-control" autocomplete="off" placeholder="Enter County"  data-parsley-trigger="focusout" data-parsley-trigger="keyup">
                                                <?php if(Session::has('county')): ?>
                                                <?php $__currentLoopData = $countyList; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $county): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                                                    <?php if(Session::get('county') == $county->id): ?>
                                                        <option selected value="<?php echo e($county->id); ?>"><?php echo e(Session::get('county_name')); ?></option>
                                                    <?php else: ?>
                                                        <option value="<?php echo e($county->id); ?>"><?php echo e($county->county_name); ?></option>
                                                    <?php endif; ?>
                                                <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>

                                                <?php endif; ?>
                                            </select>
                                    </div>
                                    <div class="col-lg-1">
                                        <button type="submit" id="update-button" class="btn btn-sm btn-primary" onclick="StateCountyUpdate();">Update</button>
                                    </div>
                                </div>
        </div>

                            

                            

                            <div class="container-fluid">
                                
                                <div class="modal fade" id="myTownship" tabindex="-1" role="dialog"
                                aria-labelledby="exampleModalLabel" aria-hidden="true">
                                <div class="modal-dialog modal-xl" role="document">
                                    <div class="modal-content">
                                        <div class="row justify-content-between mx-4 mt-2 mb-1">
                                                <div class="col-lg-2">
                                                </div>
                                                <div class="col-lg-3 mt-2">
                                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                                        <span aria-hidden="true">&times;</span>
                                                    </button>
                                                </div>
                                        </div>
                                            <div class="modal-body">
                                                <div class="p-4 table-responsive">
                                                    <table id="myTownshipTable" class="table table-bordered nowrap"
                                                    style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                                                    <thead>
                                                        <tr>
                                                            <th>Section</th>
                                                            <th>Township</th>
                                                            <th>Range</th>
                                                            <th>Quarters</th>
                                                            <th class="text-center">Vac Type</th>
                                                            <th class="text-center">Is Mapped</th>
                                                            <th class="text-center">
                                                                All <input type="checkbox" value="" id="selectall_str" name="selectall_str" class="pb-0 pt-3"/>
                                                            </th>
                                                        </tr>
                                                    </thead>
                                                    <tbody>
                                                    </tbody>
                                                </table>
                                                </div>
                                            <div class="text-center mt-3">
                                                <button type="button" class="btn btn-warning mx-2" id="addToUnderlyingBtn_str">Add to Underlying</button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                                <div class="row">
                                    <div class="col-lg-12">
                                        

                                            <div class="card">
                                                <div class="card-body" style="border-top: 3px solid #7680ff">
                                                    <form method="post" id="subdividecombineForm" name="subdividecombineForm" data-parsley-validate>
                                                        <?php echo csrf_field(); ?>
                                                        <input type="hidden" name="id" id="subdividecombine_id" />
                                                    <div class="form-group ml-2 row pb-0">
                                                        <div class="form-group col-lg-2 col-md-4 mb-1 mt-4 pb-0">
                                                            <div class="row">
                                                                <div class="input-group mb-3 ">
                                                                    <div class="input-group-prepend">
                                                                        <span class="input-group-text" >Book</span>
                                                                    </div>
                                                                    <input autocomplete="off" type="text" name="map_book"
                                                                        maxlength="10" id="map_book" class="form-control">
                                                                    <?php $__errorArgs = ['map_book'];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?>
                                                                    <span class="invalid-feedback"><?php echo e($message); ?></span>
                                                                    <?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?>
                                                                </div>
                                                            </div>
                                                        </div>
                                                        <div class="form-group col-lg-2 col-md-4 mb-1 mt-4 pb-0 mx-2">
                                                            <div class="row">
                                                                <div class="input-group mb-3">
                                                                    <div class="input-group-prepend">
                                                                        <span class="input-group-text" >Page</span>
                                                                    </div>
                                                                    <input autocomplete="off" type="text" name="map_page"
                                                                        maxlength="10" id="map_page" class="form-control">

                                                                </div>
                                                            </div>
                                                        </div>
                                                        <div class="form-group col-lg-2 col-md-4 mb-1 mt-4 pb-0 mx-2">
                                                            <div class="row">
                                                                <div class="input-group mb-3">
                                                                    <div class="input-group-prepend">
                                                                        <span class="input-group-text" >Doc #</span>
                                                                    </div>
                                                                    <input autocomplete="off" type="text" name="document_no"
                                                                        id="document_no" class="form-control"
                                                                        maxlength="20">
                                                                    <?php $__errorArgs = ['document_no'];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?>
                                                                    <span class="text-danger"><?php echo e($message); ?></span>
                                                                    <?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?>
                                                                </div>
                                                            </div>
                                                        </div>
                                                        <div class="form-group col-lg-3 col-md-3 mb-1 mt-4 pb-0 mx-2">
                                                            <div class="row">
                                                                <div class="input-group mb-2">
                                                                    <div class="input-group-prepend">
                                                                    <span class="input-group-text">Sub-Name</span>
                                                                    </div>
                                                                    <select name="subdivision_name" id="subdivision_name" class="form-control">
                                                                        <option selected disabled value="">Select Subsivision</option>
                                                                        <?php $__currentLoopData = $SubdivisionName; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $sName): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                                                                            <option value="<?php echo e($sName); ?>"><?php echo e($sName); ?></option>
                                                                        <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                                                                        <!-- Add more options as needed -->
                                                                    </select>
                                                                    <?php $__errorArgs = ['subdivision_name'];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?>
                                                                    <span class="text-danger"><?php echo e($message); ?></span>
                                                                    <?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?>
                                                                </div>
                                                            </div>
                                                        </div>
                                                        <div class="form-group col-lg-2 col-md-2 mb-1 mt-4 pb-0 mx-2">
                                                            <div class="row">
                                                                <button type="submit" class="btn btn-sm btn-primary"
                                                                    onclick="subdividecombineVal();">Search</button>
                                                            
                                                            </div>
                                                        </div>
                                                    </div>


                                                    
                                                    
                                                <form method="post" id="townshipSearch" name="townshipSearch" >
                                                        <?php echo csrf_field(); ?>
                                                    <div class="form-group ml-2 row mb-1 pb-0">
                                                        <div class="form-group col-lg-2 col-md-4 mb-1 mt-4 pb-0">
                                                            <div class="row">
                                                                <div class="input-group mb-3">
                                                                    <div class="input-group-prepend">
                                                                        <span class="input-group-text">Township</span>
                                                                    </div>
                                                                    <input type="text" name="township" id="township"
                                                                        class="form-control" maxlength="4" autocomplete="off" style='text-transform:uppercase'>
                                                                    <?php $__errorArgs = ['township'];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?>
                                                                    <span class="text-danger"><?php echo e($message); ?></span>
                                                                    <?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?>
                                                                </div>
                                                            </div>
                                                        </div>
                                                        <div class="form-group col-lg-2 col-md-4 mb-1 mt-4 pb-0 mx-2">
                                                            <div class="row">
                                                                <div class="input-group  mb-3">
                                                                    <div class="input-group-prepend">
                                                                        <span class="input-group-text">Range</span>
                                                                    </div>
                                                                    <input type="text" name="range"
                                                                        id="range" class="form-control"
                                                                        maxlength="4" autocomplete="off" style='text-transform:uppercase'>
                                                                    <?php $__errorArgs = ['range'];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?>
                                                                    <span class="text-danger"><?php echo e($message); ?></span>
                                                                    <?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?>
                                                                </div>
                                                            </div>
                                                        </div>
                                                        <div class="form-group col-lg-2 col-md-4 mb-1 mt-4 pb-0 mx-2">
                                                            <div class="row">
                                                                <div class="input-group mb-3">
                                                                    <div class="input-group-prepend">
                                                                        <span class="input-group-text">Section</span>
                                                                    </div>
                                                                    <input type="number" name="section"  min="1" max="999" id="section" class="form-control" autocomplete="off">
                                                                    <?php $__errorArgs = ['section'];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?>
                                                                    <span class="invalid-feedback"><?php echo e($message); ?></span>
                                                                    <?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?>
                                                                </div>
                                                            </div>
                                                        </div>
                                                        <div class="form-group col-lg-3 col-md-3 mb-1 mt-4 pb-0 mx-2">
                                                            <div class="row">
                                                                <div class="input-group mb-3">
                                                                    <div class="input-group-prepend">
                                                                        <span class="input-group-text">Quarter</span>
                                                                    </div>
                                                                    <input type="text" name="quarter"  maxlength="20" id="quarter" class="form-control" autocomplete="off" style='text-transform:uppercase'>
                                                                </div>
                                                                <?php $__errorArgs = ['quarter'];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?>
                                                                    <div class="text-danger"><?php echo e($message); ?></div>
                                                                <?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?>
                                                            </div>
                                                        </div>
                                                        <div class="form-group col-lg-2 col-md-2 mb-1 mt-4 pb-0 mx-2">
                                                            <div class="row">
                                                                <button type="submit" class="btn btn-sm btn-primary"  onclick="townshipSearch();" id="searchButton">Search</button>
                                                        </div>
                                                    </div>
                                                </form>
                                                </div>
                                            </div>
                                    </div>
                                </div>
                            </div>
                                    
                                    
                                   <div class="p-4 table-responsive">
                                        <div class="row">
                                            <!-- Underlying Property -->
                                            <div class="col-md-6">
                                            <h5 class="text-center"><strong>Underlying Property</strong></h5>
                                            <br>
                                            <div class="row">
                                                <div class="col-md-4">
                                                <div class="form-group">
                                                    <label class="custom-label" for="underlying_book">Book:</label>
                                                    <span class="custom-span" id="underlying_book"></span>
                                                </div>
                                                <div class="form-group">
                                                    <label class="custom-label" for="underlying_page">Page:</label>
                                                    <span class="custom-span" id="underlying_page"></span>
                                                </div>
                                                <div class="form-group">
                                                    <label class="custom-label" for="underlying_recDate">Rec-Date:</label>
                                                    <span class="custom-span" id="underlying_recDate"></span>
                                                </div>
                                                </div>
                                                <div class="col-md-8">
                                                <div class="form-group">
                                                    <label class="custom-label" for="underlying_sMap">S.Map#:</label>
                                                    <span class="custom-span" id="underlying_sMap"></span>
                                                </div>
                                                <div class="form-group">
                                                    <label class="custom-label" for="underlying_doc">Doc#:</label>
                                                    <span class="custom-span" id="underlying_doc"></span>
                                                </div>
                                                <div class="form-group">
                                                    <label class="custom-label" for="underlying_subName">Sub-Name:</label>
                                                    <span class="custom-span" id="underlying_subName"></span>
                                                </div>
                                                </div>
                                            </div>
                                            <div>
                                                <table id="underlyingTable" class="table table-bordered nowrap underlying-table">
                                                    <thead>
                                                    <tr>
                                                        <th></th>
                                                        <th>Block</th>
                                                        <th>Lot</th>
                                                        <th>APN #</th>
                                                        <th>Status</th>
                                                        <th>Date</th>
                                                    </tr>
                                                    </thead>
                                                    <tbody>
                                                    <!-- Table content goes here -->
                                                    </tbody>
                                                </table>
                                            </div>
                                            <div>
                                                <table id="underlyingTable_str" class="table table-bordered nowrap underlying-table d-none">
                                                    <thead>
                                                    <tr>
                                                        <th></th>
                                                        <th>Sec</th>
                                                        <th>Twn</th>
                                                        <th>Range</th>
                                                        <th>QTR</th>
                                                        <th>Status</th>
                                                        <th>Date</th>
                                                    </tr>
                                                    </thead>
                                                    <tbody>
                                                    <!-- Table content goes here -->
                                                    </tbody>
                                                </table>
                                            </div>
                                            </div>

                                            <!-- overlying Property -->
                                            <div class="col-md-6">
                                            <h5 class="text-center"><strong>Overlying Property</strong></h5>
                                            <br>
                                            <div class="row">
                                                <div class="col-md-4">
                                                <div class="form-group">
                                                    <label class="custom-label" for="overlying_book">Book:</label>
                                                    <span class="custom-span" id="overlying_book"></span>
                                                </div>
                                                <div class="form-group">
                                                    <label class="custom-label" for="overlying_page">Page:</label>
                                                    <span class="custom-span" id="overlying_page"></span>
                                                </div>
                                                <div class="form-group">
                                                    <label class="custom-label" for="overlying_recDate">Rec-Date:</label>
                                                    <span class="custom-span" id="overlying_recDate"></span>
                                                </div>
                                                </div>
                                                <div class="col-md-8">
                                                <div class="form-group">
                                                    <label class="custom-label" for="overlying_sMap">S.Map#:</label>
                                                    <span class="custom-span" id="overlying_sMap"></span>
                                                </div>
                                                <div class="form-group">
                                                    <label class="custom-label" for="overlying_doc">Doc#:</label>
                                                    <span class="custom-span" id="overlying_doc"></span>
                                                </div>
                                                <div class="form-group">
                                                    <label class="custom-label" for="overlying_subName">Sub-Name:</label>
                                                    <span class="custom-span" id="overlying_subName"></span>
                                                </div>
                                                </div>
                                            </div>
                                            <table id="overlyingTable" class="table table-bordered nowrap overlying-table">
                                                <thead>
                                                <tr>
                                                    <th></th>
                                                    <th>Block</th>
                                                    <th>Lot</th>
                                                    <th>APN #</th>
                                                    <th>Status</th>
                                                    <th>Date</th>
                                                </tr>
                                                </thead>
                                                <tbody>
                                                <!-- Table content goes here -->
                                                </tbody>
                                            </table>
                                            </div>
                                        </div>


                                        </div>
                                    
                                    <div class="p-4">
                                        <div class="row">
                                            <div class="col-lg-2">
                                                <button class="btn btn-info mt-2 d-none" id="show-history" onclick="showHistroy();">
                                                    <i class="fas fa-clock"></i> Show History
                                                </button>
                                            </div>
                                            <div class="col-lg-3 mt-2 mb-2">
                                                <select class="form-control" id="reference_type" name="reference_type">
                                                    <option disabled value="">Select Reference Type</option>
                                                        <option selected value="1">Came From</option>
                                                </select>
                                            </div>
                                            <div class="col-lg-2 mt-2 mb-2">
                                                <select disabled class="form-control" id="block_lot_type_option" name="block_lot_type_option">
                                                    <?php $__currentLoopData = $block_lot_types; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $plot_type): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                                                        <?php if($plot_type->id == 1): ?>
                                                            <option selected disabled value="">Select Vacated Type</option>
                                                        <?php else: ?>
                                                            <option value="<?php echo e($plot_type->id); ?>"><?php echo e($plot_type->type); ?></option>
                                                        <?php endif; ?>
                                                    <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                                                </select>
                                            </div>
                                            <div class="col-lg-3 mt-2 mb-2">
                                                <div class="input-group mb-3 mx-0">
                                                    <div class="input-group-prepend">
                                                        <span class="input-group-text">Replat Date</span>
                                                    </div>
                                                    <input autocomplete="off" type="date" name="replat_date" id="replat_date" class="form-control"  value="">
                                                    <?php $__errorArgs = ['date'];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?>
                                                    <span class="invalid-feedback"><?php echo e($message); ?></span>
                                                    <?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="row">
                                            <div class="col-lg-5"></div>
                                            <div class="col-lg-2 mt-2 mb-2 mr-4 text-center">
                                                <button type="button" class="btn btn-primary mx-2" id="submitcombine">Save Mapping</button>
                                            </div>
                                            <div class="col-lg-5"></div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- Histroy Modal -->
    <div class="modal fade" id="myHistory" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog modal-xl" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Mapping History</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    
                </div>
            </div>
        </div>
    </div>
    <!-- Histroy Modal Ends -->
    
    <div class="modal fade" id="myPlat" tabindex="-1" role="dialog"
        aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog modal-xl" role="document">
            <div class="modal-content">
                <div class="row justify-content-between mx-4 mt-2 mb-1">
                        <div class="col-lg-2">
                        </div>
                        <div class="col-lg-3 mt-2">
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                </div>
                    <div class="modal-body">
                        <div class="p-4 table-responsive">
                            <table id="myPlotTable" class="table table-bordered nowrap" style="width: 100%;">
                                <thead>
                                    <tr>
                                        <th>Sub-Name</th>
                                        <th>Block</th>
                                        <th>Lot</th>
                                        <th>APN #</th>
                                        <th>Date</th>
                                        <th class="text-center">Vac Type</th>
                                        <th class="text-center">Is Mapped</th>
                                        <th class="text-center">
                                            All <input type="checkbox" value="" id="selectall" name="selectall" class="pb-0 pt-3"/>
                                        </th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <!-- This row is optional and can be used to display a "No Records found" message -->
                                    <tr>
                                        <td colspan="8" class="text-center">No Records found</td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                        <div class="text-center mt-3">
                            <button type="button" class="btn btn-warning mx-2" id="addToUnderlyingBtn">Add to Underlying</button>
                            <button type="button" disabled class="btn btn-primary mx-2" id="addToOverlyingBtn">Add to Overlying</button>
                        </div>
                    </div>
    </div>
</div>


<script type="text/javascript">
    var userRole = 3;
    $(document).ready(function () {
        $('#underlyingTable').DataTable({
            responsive: true,
            searching: false,
            lengthChange: false,
            info: false,
            paging: false,
        });

        $('#subdivision_name').select2();

        userRole = "<?php echo Session::get('user_type_id'); ?>";

        $("#selectall").on('change', function(){
            if ($("input[type=checkbox]").hasClass("checkclass")) {
                $("input[type=checkbox]").prop("checked", false).removeClass('checkclass');
            } else {
                $("input[type=checkbox]").prop("checked", true).addClass('checkclass');
            }
        });

        $("#selectall_str").on('change', function(){
            if ($("input[type=checkbox]").hasClass("checkclass")) {
                $("input[type=checkbox]").prop("checked", false).removeClass('checkclass');
            } else {
                $("input[type=checkbox]").prop("checked", true).addClass('checkclass');
            }
        });


        $('#overlyingTable').DataTable({
            responsive: true,
            searching: false,
            lengthChange: false,
            info: false,
            paging: false,
        });
    });

    $(function () {
        <?php if(Session::has('success')): ?>
        new PNotify({
            title: 'Success',
            delay: 500,
            text: "<?php echo e(Session::get('success')); ?>",
            type: 'success'
        });

        <?php endif; ?>
        <?php if($errors -> any()): ?>
        var err = "";
        <?php $__currentLoopData = $errors -> all(); $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $error): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>

        new PNotify({
            title: 'Error',
            text: "<?php echo e($error); ?>",
            delay: 800,
            type: 'error'
        });
        <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
        <?php endif; ?>
    });

    // Initially, hide the "Update" button
    $("#update-button").hide();

    // When the state select changes
    $("#state").change(function() {
        $("#update-button").hide();
    });

    // When the county select changes
    $("#county").change(function() {
        // Check if a county is selected
        if ($(this).val() !== "Select County") {
            // Hide the "Update" button if county is selected
            $("#update-button").show();
        } else {
            $("#update-button").hide();
        }
    });

    function StateCountyUpdate() {
        var selectedState = $("#state").val();
        var selectedCounty = $("#county").val();
        var csrfToken = "<?php echo e(csrf_token()); ?>";

        $.ajax({
            type: 'POST',
            url: "<?php echo e(route('StateCountyUpdate')); ?>",
            data: {
                _token: csrfToken,
                state: selectedState,
                county: selectedCounty
            },
            dataType: 'json',
            success: function (response) {
                if (response.msg == "State and County Updated Successfully!") {
                    new PNotify({
                        title: 'Success',
                        text: response.msg,
                        type: 'success'
                    });
                    setTimeout(function () {
                        location.reload();
                    }, 500);
                    $("#update-button").hide();
                }
            },
            error: function (error) {
                new PNotify({
                    title: 'Error',
                    text: "State and County Updation failed!",
                    type: 'error'
                });
            }
        });
    }

    $('#state').on('change', function () {
        // $("#county").select2();
        var state_id = $("#state").val();
        $("#county").html('');
        $.ajax({
            url: "<?php echo e(route('getCounty')); ?>",
            type: "POST",
            data: {
                state_id: state_id,
                _token: '<?php echo e(csrf_token()); ?>'
            },
            dataType: 'json',
            success: function (result) {
                $('#county').html('<option value="">Select County</option>');
                $.each(result.counties, function (key, value) {
                    $("#county").append('<option value="' + value
                        .id + '">' + value.county_name + '</option>');
                });
            }
        });
    });

var response;
function subdividecombineVal() {
    if ($("#subdividecombineForm").parsley()) {
        if ($("#subdividecombineForm").parsley().validate()) {
            event.preventDefault();
            if ($("#subdividecombineForm").parsley().isValid()) {
                $.ajax({
                    type: "POST",
                    cache: false,
                    async: false,
                    url: "<?php echo e(url('/getSubdivideData')); ?>",
                    data: new FormData($("#subdividecombineForm")[0]),
                    processData: false,
                    contentType: false,
                    success: function (data) {
                        response = data;
                        if (response.length > 0) {
                            $('#myPlat').modal('show');
                            if ($.fn.DataTable.isDataTable('#myPlotTable')) {
                                // Destroy the existing DataTable
                                $('#myPlotTable').DataTable().destroy();
                            }
                            // Initialize DataTable with JSON response data
                            var dataTable = $('#myPlotTable').DataTable({
                                responsive: true,
                                searching: true,
                                data: response,
                                "bFilter": true,
                                "order": [[1, 'asc'], [2, 'asc']],
                                columns: [
                                    // { data: null,
                                    //     render: function (data, type, row, meta) {
                                    //         return meta.row + 1;
                                    //     }
                                    // },
                                    { data: 'subdivisions.subdivision_name' },
                                    { data: 'block' },
                                    { data: 'lot' },
                                    { data: 'apn_no' },
                                    {
                                        data: 'date',
                                        render: function (data) {
                                            if (data === null) {
                                                return "";
                                            } else {
                                                return moment(data).format('MM/DD/YYYY');
                                            }
                                        }
                                    },
                                    { data: 'plat_types.type' },
                                    {
                                        data: null,
                                        render: function (data, type, row) {
                                            if (userRole == 1) {
                                                if (row.underlying_block_lots && row.underlying_block_lots.length > 0) {
                                                    return '<i style="color:green; text-align: center;" class="fas fa-map-marked-alt ml-4 clickable-svg" onclick="handleIconClick(' + row.id + ')"></i>&nbsp;&nbsp;&nbsp;&nbsp;<i style="color:red; text-align: center;" class="dripicons-trash" onclick="removeUnderlyingRow(this,'+ row.id+')"></i>';
                                                } else if (row.plat_types.type != "PLAT") {
                                                    return '<i style="color:orange; text-align: center;" class="fas fa-exclamation-triangle ml-4" onclick="handleIconClick(' + row.id + ')"></i>&nbsp;&nbsp;&nbsp;&nbsp;<i style="color:red; text-align: center;" class="dripicons-trash" onclick="removeUnderlyingRow(this,'+ row.id+')"></i>';
                                                } else {
                                                    return '<i style="color:orange; text-align: center;" class="fas fa-map-marked-alt ml-4" onclick="handleIconClick(' + row.id + ')"></i>';
                                                }
                                            } else if (userRole == 2) {
                                                if (row.underlying_block_lots && row.underlying_block_lots.length > 0) {
                                                    return '<i style="color:green; text-align: center;" class="fas fa-map-marked-alt ml-4 clickable-svg" onclick="handleIconClick(' + row.id + ')"></i>&nbsp;&nbsp;&nbsp;&nbsp;<i style="color:red; text-align: center;" class="dripicons-trash" onclick="removeUnderlyingRow(this,'+ row.id+')"></i>';
                                                } else if (row.plat_types.type != "PLAT") {
                                                    return '<i style="color:orange; text-align: center;" class="fas fa-exclamation-triangle ml-4" onclick="handleIconClick(' + row.id + ')"></i>&nbsp;&nbsp;&nbsp;&nbsp;<i style="color:red; text-align: center;" class="dripicons-trash" onclick="removeUnderlyingRow(this,'+ row.id+')"></i>';
                                                } else {
                                                    return '<i style="color:orange; text-align: center;" class="fas fa-map-marked-alt ml-4" onclick="handleIconClick(' + row.id + ')"></i>';
                                                }
                                            } else {
                                                if (row.underlying_block_lots && row.underlying_block_lots.length > 0) {
                                                    return '<i style="color:green; text-align: center;" class="fas fa-map-marked-alt ml-4 clickable-svg" onclick="handleIconClick(' + row.id + ')"></i>';
                                                } else {
                                                    return '<i style="color:orange; text-align: center;" class="fas fa-map-marked-alt ml-4" onclick="handleIconClick(' + row.id + ')"></i>';
                                                }
                                            }
                                        }
                                    },
                                    {
                                        data: null,
                                        render: function (data, type, row) {
                                            return '<input style="text-align: center;" type="checkbox" class="fetchButton text-center ml-4" name="checkboxColumn[]" id="select_' + row.id  + '" value="' + row.id + '">';
                                        }
                                    },
                                ],
                                lengthMenu: [10,50,100,500,1000],
                                createdRow: function (row, data, dataIndex) {
                                    // Set the data-id attribute on the row element
                                    $(row).attr('data-id', data.id);
                                },
                                initComplete: function () {
                                    $(".modal-search-filter").remove();
                                    this.api().columns().every(function () {
                                        var column = this;
                                        var header = $(column.header());
                                        var input = $('<input type="text" placeholder="" class="form-control form-control-sm modal-search-filter" style="text-transform:uppercase" />')
                                            .appendTo(header)
                                            .on('keyup change', function () {
                                                column.search($(this).val()).draw();
                                            });
                                    });
                                }
                            });
                            new PNotify({
                                title: 'Success',
                                text: 'Data Fetched Successfully',
                                type: 'success',
                                delay: 500
                            });
                        } else {
                            if ($.fn.DataTable.isDataTable('#myPlotTable')) {
                                $('#myPlotTable').DataTable().clear().draw();
                            }
                            new PNotify({
                                text: 'No data found.',
                                type: 'warning',
                                delay: 500
                            });
                        }
                    },
                    error: function (response) {

                        var err = "";
                        $.each(response.responseJSON.errors, function (field_name, error) {
                            err = err + error;
                        });
                        new PNotify({
                            title: 'Error',
                            text: err,
                            type: 'error',
                            delay: 500
                        });
                    }
                });
            }
        }
    }
}


function townshipSearch() {
    event.preventDefault();
    var section = $("#section").val();
    var township = $("#township").val();
    var range = $("#range").val();
    var quarter = $("#quarter").val();

    var formData = {
        "_token": "<?php echo e(csrf_token()); ?>",
        "section": section,
        "township": township,
        "range": range,
        "quarter": quarter
    };
    $.ajax({
        type: "POST",
        cache: false,
        async: false,
        url: "<?php echo e(url('/getStrData')); ?>",
        data: formData, // Send the JavaScript object as data
        success: function (data) {

            // Assuming response is an array of objects as shown in your example
             response = data;
            var table = $('#myTownshipTable').DataTable({
                "destroy": true, // Destroy the existing DataTable (if any)
                "data": response,
                "bFilter": true,
                "columns": [
                    // {
                    //     "data": null,
                    //     "render": function (data, type, row, meta) {
                    //         return meta.row + 1;
                    //     }
                    // },
                    { "data": "section" },
                    { "data": "township" },
                    { "data": "range" },
                    { "data": "quarter" },
                    { "data": 'plat_types.type' },
                    {
                        data: null,
                        render: function (data, type, row) {
                            if (userRole == 1) {
                                if (row.str_bridge && row.str_bridge.length > 0) {
                                    return '<i style="color:green; text-align: center;" class="fas fa-map-marked-alt ml-4 clickable-svg" onclick="handleIconClick_str(' + row.id + ')"></i>&nbsp;&nbsp;&nbsp;&nbsp;<i style="color:red; text-align: center;" class="dripicons-trash" onclick="removeUnderlyingStrRow(this,'+ row.id+')"></i>';
                                } else if (row.plat_types.type != "PLAT") {
                                    return '<i style="color:orange; text-align: center;" class="fas fa-exclamation-triangle ml-4" onclick="handleIconClick_str(' + row.id + ')"></i>&nbsp;&nbsp;&nbsp;&nbsp;<i style="color:red; text-align: center;" class="dripicons-trash" onclick="removeUnderlyingStrRow(this,'+ row.id+')"></i>';
                                } else {
                                    return '<i style="color:orange; text-align: center;" class="fas fa-map-marked-alt ml-4" onclick="handleIconClick_str(' + row.id + ')"></i>';
                                }
                            } else if (userRole == 2) {
                                if (row.str_bridge && row.str_bridge.length > 0) {
                                    return '<i style="color:green; text-align: center;" class="fas fa-map-marked-alt ml-4 clickable-svg" onclick="handleIconClick_str(' + row.id + ')"></i>&nbsp;&nbsp;&nbsp;&nbsp;<i style="color:red; text-align: center;" class="dripicons-trash" onclick="removeUnderlyingStrRow(this,'+ row.id+')"></i>';
                                } else if (row.plat_types.type != "PLAT") {
                                    return '<i style="color:orange; text-align: center;" class="fas fa-exclamation-triangle ml-4" onclick="handleIconClick_str(' + row.id + ')"></i>&nbsp;&nbsp;&nbsp;&nbsp;<i style="color:red; text-align: center;" class="dripicons-trash" onclick="removeUnderlyingStrRow(this,'+ row.id+')"></i>';
                                } else {
                                    return '<i style="color:orange; text-align: center;" class="fas fa-map-marked-alt ml-4" onclick="handleIconClick_str(' + row.id + ')"></i>';
                                }
                            } else {
                                if (row.str_bridge && row.str_bridge.length > 0) {
                                    return '<i style="color:green; text-align: center;" class="fas fa-map-marked-alt ml-4 clickable-svg" onclick="handleIconClick_str(' + row.id + ')"></i>';
                                } else {
                                    return '<i style="color:orange; text-align: center;" class="fas fa-map-marked-alt ml-4" onclick="handleIconClick_str(' + row.id + ')"></i>';
                                }
                            }
                        }
                    },
                    {
                        "data": null,
                        "render": function (data, type, row) {
                            return '<input style="text-align: center;" type="checkbox" class="fetchButton text-center ml-4" name="checkboxColumn" value="' + row.id + '">';
                        }
                    }
                ],
                lengthMenu: [10,50,100,500,1000],
                createdRow: function (row, data, dataIndex) {
                    // Set the data-id attribute on the row element
                    $(row).attr('data-id', data.id);
                },
                initComplete: function () {
                    $(".modal-search-filter").remove();
                    this.api().columns().every(function () {
                        var column = this;
                        var header = $(column.header());
                        var input = $('<input type="text" placeholder="" class="form-control form-control-sm modal-search-filter" style="text-transform:uppercase" />')
                            .appendTo(header)
                            .on('keyup change', function () {
                                column.search($(this).val()).draw();
                            });
                    });
                }
            });
            table.draw();
            $('#myTownship').modal('show');
        },
        error: function (response) {
            var err = "";
            $.each(response.responseJSON.errors, function (field_name, error) {
                err = err + error;
            });
            // Handle the error response here
        }
    });
}


function handleIconClick(rowId) {
    var historyId = [];
    historyId.push(rowId);
    var data = {
        underlying_block_lot_id: historyId,
        _token: "<?php echo e(csrf_token()); ?>",
        history_check : true
    };
    var modalBody = $("#myHistory .modal-body");
    modalBody.empty();
    $('#myPlat').modal('hide');
    if ($.fn.DataTable.isDataTable('#myTable_History0')) {
        $('#myTable_History0').DataTable().clear().draw();
    }
    if ($.fn.DataTable.isDataTable('#myTable_History1')) {
        $('#myTable_History1').DataTable().clear().draw();
    }
    $.ajax({
        type: 'POST',
        url: "<?php echo e(url('/viewSubdivisionBridge')); ?>",
        data: data,
        success: function (data4) {
            // Show button
            if (data4.hasOwnProperty('historyData_0') && data4.historyData_0 && data4.historyData_0.length > 0) {
                modalBody.append(createTable("myTable_History_Parent"));
                var historyData = data4.historyData_0; // Assuming you have data in data2.historyData_0
                var table = $('#myTable_History_Parent').DataTable({
                    "destroy": true, // Destroy the existing DataTable instance, if any
                    "paging": false,
                    "searching": false,
                    "ordering": true,
                    "order": [[4, 'asc'], [5, 'asc'], [6, 'asc']],
                    "data": historyData,
                    "columns": [
                        {
                            data: null,
                            render: function (data, type, row) {
                                // Create a radio button element with an onclick event
                                return '<input type="radio" name="rowRadio" onclick="handleIconClick(' + row.id + ')">';
                            }
                        },
                        { "data": "subdivisions.map_book" },
                        { "data": "subdivisions.map_page" },
                        { "data": "subdivisions.map_no" },
                        { "data": "subdivisions.document_no" },
                        { "data": "subdivisions.subdivision_name" },
                        { "data": "block" },
                        { "data": "lot" },
                        { "data": "comments" },
                        { "data": "plat_types.type" },
                        {
                            data: 'date',
                            render: function (data) {
                                if (data === null) {
                                    return "";
                                } else {
                                    return moment(data).format('MM/DD/YYYY');
                                }
                            }
                        },
                    ],
                    "columnDefs": [
                        {
                            "targets": [6], // Column index for "Vacated Status"
                            "orderable": false // Disable sorting for "Vacated Status" column
                        }
                    ],
                });
            } else if (data4.hasOwnProperty('historyData_0_str') && data4.historyData_0_str && data4.historyData_0_str.length > 0) {
                modalBody.append(createTable_str("myTable_History_Parent"));
                var historyData = data4.historyData_0_str; // Assuming you have data in data2.historyData_0
                var table = $('#myTable_History_Parent').DataTable({
                    "destroy": true, // Destroy the existing DataTable instance, if any
                    "paging": false,
                    "searching": false,
                    "ordering": true,
                    "order": [[1, 'asc'], [2, 'asc'], [3, 'asc'], [4, 'asc']],
                    "data": historyData,
                    "columns": [
                        {
                            data: null,
                            render: function (data, type, row) {
                                // Create a radio button element with an onclick event
                                return '<input type="radio" name="rowRadio" onclick="handleIconClick_str(' + row.id + ')">';
                            }
                        },
                        { "data": "section" },
                        { "data": "township" },
                        { "data": "range" },
                        { "data": "quarter" },
                        { "data": "comments" },
                        { "data": "plat_types.type" },
                        {
                            data: 'vacated_date',
                            render: function (data) {
                                if (data === null) {
                                    return "";
                                } else {
                                    return moment(data).format('MM/DD/YYYY');
                                }
                            }
                        },
                    ],
                    "columnDefs": [
                        {
                            "targets": [6], // Column index for "Vacated Status"
                            "orderable": false // Disable sorting for "Vacated Status" column
                        }
                    ],
                });
            } else {
                console
                modalBody.append(createTable("myTable_History_Parent"));
                $("#myTable_History_Parent tbody").html("<tr><td colspan='11' class='text-center'>No records found</td></tr>");
            }


            if (data4.hasOwnProperty('underlyingPlats') && data4.underlyingPlats && data4.underlyingPlats.length > 0) {
                modalBody.append(createTable("myTable_History0"));
                var historyData = data4.underlyingPlats; // Assuming you have data in data2.historyData_0
                var filteredData = historyData.filter(function(row) {
                    return row.id === historyId[0];
                });
                var table = $('#myTable_History0').DataTable({
                    "destroy": true, // Destroy the existing DataTable instance, if any
                    "paging": false,
                    "searching": false,
                    "ordering": true,
                    "order": [[4, 'asc'], [5, 'asc'], [6, 'asc']],
                    "data": filteredData,
                    "columns": [
                        {
                            data: null,
                            render: function (data, type, row) {
                                // Create a radio button element with an onclick event
                                return '<input type="radio" checked name="rowRadio">';
                            }
                        },
                        { "data": "subdivisions.map_book" },
                        { "data": "subdivisions.map_page" },
                        { "data": "subdivisions.map_no" },
                        { "data": "subdivisions.document_no" },
                        { "data": "subdivisions.subdivision_name" },
                        { "data": "block" },
                        { "data": "lot" },
                        { "data": "comments" },
                        { "data": "plat_types.type" },
                        {
                            data: 'date',
                            render: function (data) {
                                if (data === null) {
                                    return "";
                                } else {
                                    return moment(data).format('MM/DD/YYYY');
                                }
                            }
                        },
                    ],
                    "columnDefs": [
                        {
                            "targets": [6], // Column index for "Vacated Status"
                            "orderable": false // Disable sorting for "Vacated Status" column
                        }
                    ],
                });
            } else {
                modalBody.append(createTable("myTable_History0"));
                $("#myTable_History0 tbody").html("<tr><td colspan='11' class='text-center'>No records found</td></tr>");
            }

            if (data4.hasOwnProperty('overlyingPlats') && data4.overlyingPlats && data4.overlyingPlats.length > 0) {
                modalBody.append(createTable("myTable_History1"));
                var historyData = data4.overlyingPlats; // Assuming you have data in data2.historyData_0
                var table = $('#myTable_History1').DataTable({
                    "destroy": true, // Destroy the existing DataTable instance, if any
                    "paging": false,
                    "searching": false,
                    "ordering": true,
                    "order": [[4, 'asc'], [5, 'asc'], [6, 'asc']],
                    "data": historyData,
                    "columns": [
                        {
                            data: null,
                            render: function (data, type, row) {
                                // Create a radio button element with an onclick event
                                return '<input type="radio" name="rowRadio" onclick="handleIconClick(' + row.id + ')">';
                            }
                        },
                        { "data": "subdivisions.map_book" },
                        { "data": "subdivisions.map_page" },
                        { "data": "subdivisions.map_no" },
                        { "data": "subdivisions.document_no" },
                        { "data": "subdivisions.subdivision_name" },
                        { "data": "block" },
                        { "data": "lot" },
                        { "data": "comments" },
                        { "data": "plat_types.type" },
                        {
                            data: 'date',
                            render: function (data) {
                                if (data === null) {
                                    return "";
                                } else {
                                    return moment(data).format('MM/DD/YYYY');
                                }
                            }
                        },
                    ],
                    "columnDefs": [
                        {
                            "targets": [6], // Column index for "Vacated Status"
                            "orderable": false // Disable sorting for "Vacated Status" column
                        }
                    ],
                });
            } else {
                modalBody.append(createTable("myTable_History1"));
                $("#myTable_History1 tbody").html("<tr><td colspan='11' class='text-center'>No records found</td></tr>");
            }

            $('#myHistory').modal('show');
        }
    });
}

function handleIconClick_str(rowId) {
    var historyId = [];
    historyId.push(rowId);
    var data = {
        underlying_block_lot_id: historyId,
        _token: "<?php echo e(csrf_token()); ?>",
        is_str: true,
        history_check : true
    };
    var modalBody = $("#myHistory .modal-body");
    modalBody.empty();
    modalBody.append(createTable_str("myTable_History0"));
    modalBody.append(createTable("myTable_History1"));
    $('#myTownship').modal('hide');
    if ($.fn.DataTable.isDataTable('#myTable_History0')) {
        $('#myTable_History0').DataTable().clear().draw();
    }
    if ($.fn.DataTable.isDataTable('#myTable_History1')) {
        $('#myTable_History1').DataTable().clear().draw();
    }
    $.ajax({
        type: 'POST',
        url: "<?php echo e(url('/viewSubdivisionBridge')); ?>",
        data: data,
        success: function (data4) {
            if (data4.hasOwnProperty('underlyingPlats') && data4.underlyingPlats && data4.underlyingPlats.length > 0) {
                var historyData = data4.underlyingPlats; // Assuming you have data in data2.historyData_0
                var filteredData = historyData.filter(function(row) {
                    return row.id === historyId[0];
                });
                var table = $('#myTable_History0').DataTable({
                    "destroy": true, // Destroy the existing DataTable instance, if any
                    "paging": false,
                    "searching": false,
                    "ordering": true,
                    "order": [[1, 'asc'], [2, 'asc'], [3, 'asc'], [4, 'asc']],
                    "data": filteredData,
                    "columns": [
                        {
                            data: null,
                            render: function (data, type, row) {
                                // Create a radio button element with an onclick event
                                return '<input type="radio" checked name="rowRadio">';
                            }
                        },
                        { "data": "section" },
                        { "data": "township" },
                        { "data": "range" },
                        { "data": "quarter" },
                        { "data": "comments" },
                        { "data": "plat_types.type" },
                        {
                            data: 'vacated_date',
                            render: function (data) {
                                if (data === null) {
                                    return "";
                                } else {
                                    return moment(data).format('MM/DD/YYYY');
                                }
                            }
                        },
                    ],
                    "columnDefs": [
                        {
                            "targets": [6], // Column index for "Vacated Status"
                            "orderable": false // Disable sorting for "Vacated Status" column
                        }
                    ],
                });
            } else {
                    $("#myTable_History0 tbody").html("<tr><td colspan='8' class='text-center'>No records found</td></tr>");
            }

            if (data4.hasOwnProperty('overlyingPlats') && data4.overlyingPlats && data4.overlyingPlats.length > 0) {
                var historyData = data4.overlyingPlats; // Assuming you have data in data2.historyData_0
                var table = $('#myTable_History1').DataTable({
                    "destroy": true, // Destroy the existing DataTable instance, if any
                    "paging": false,
                    "searching": false,
                    "ordering": true,
                    "order": [[4, 'asc'], [5, 'asc'], [6, 'asc']],
                    "data": historyData,
                    "columns": [
                        {
                            data: null,
                            render: function (data, type, row) {
                                // Create a radio button element with an onclick event
                                return '<input type="radio" name="rowRadio" onclick="handleIconClick(' + row.id + ')">';
                            }
                        },
                        { "data": "subdivisions.map_book" },
                        { "data": "subdivisions.map_page" },
                        { "data": "subdivisions.map_no" },
                        { "data": "subdivisions.document_no" },
                        { "data": "subdivisions.subdivision_name" },
                        { "data": "block" },
                        { "data": "lot" },
                        { "data": "comments" },
                        { "data": "plat_types.type" },
                        {
                            data: 'date',
                            render: function (data) {
                                if (data === null) {
                                    return "";
                                } else {
                                    return moment(data).format('MM/DD/YYYY');
                                }
                            }
                        },
                    ],
                    "columnDefs": [
                        {
                            "targets": [6], // Column index for "Vacated Status"
                            "orderable": false // Disable sorting for "Vacated Status" column
                        }
                    ],
                });
            } else {
                $("#myTable_History1 tbody").html("<tr><td colspan='11' class='text-center'>No records found</td></tr>");
            }
            $('#myHistory').modal('show');
        }
    });
}

function createTable_str(tableId) {
    return `<h5 class="text-center">${tableId === 'myTable_History0' ? 'Selected Plat' : tableId === 'myTable_History1' ? 'Overlying of Selected Plat' : 'Underlying of Selected Plat' }</h5>
            <div class="p-4 table-responsive">
                <table id="${tableId}" class="table table-bordered nowrap" style="width: 100%;">
                    <thead>
                        <tr>
                            ${'<th></th>'}
                            ${tableId === 'myTable_History0' ? '<th>Section</th>' : tableId === 'myTable_History1' ? '<th>Book</th>' : '<th>Section</th>'}
                            ${tableId === 'myTable_History0' ? '<th>Township</th>' : tableId === 'myTable_History1' ? '<th>Page</th>' : '<th>Township</th>'}
                            ${tableId === 'myTable_History0' ? '<th>Range</th>' : tableId === 'myTable_History1' ? '<th>S.Map #</th>' : '<th>Range</th>'}
                            ${tableId === 'myTable_History0' ? '<th>Quarter</th>' : tableId === 'myTable_History1' ? '<th>Doc #</th>' : '<th>Quarter</th>'}
                            ${tableId === 'myTable_History0' ? '<th>Comments</th>' : tableId === 'myTable_History1' ? '<th>Sub-Name</th>' : '<th>Comments</th>'}
                            ${tableId === 'myTable_History0' ? '<th>Vacated Status</th>' : tableId === 'myTable_History1' ? '<th>Block</th>' : '<th>Vacated Status</th>'}
                            ${tableId === 'myTable_History0' ? '<th>Vacated Date</th>' : tableId === 'myTable_History1' ? '<th>Lot</th>' : '<th>Vacated Date</th>'}
                            ${tableId === 'myTable_History0' ? '' : tableId === 'myTable_History1' ? '<th>Comments</th>' : ''}
                            ${tableId === 'myTable_History0' ? '' : tableId === 'myTable_History1' ? '<th>Vacated Status</th>' : ''}
                            ${tableId === 'myTable_History0' ? '' : tableId === 'myTable_History1' ? '<th>Vacated Date</th>' : ''}
                        </tr>
                    </thead>
                    <tbody>
                        <tr>
                            <td colspan="${tableId === 'myTable_History0' ? '8' : tableId === 'myTable_History1' ? '11' : '8'}" class="text-center">No Records found</td>
                        </tr>
                    </tbody>
                </table>
            </div>`;
}


function createTable(tableId) {
    return `<h5 class="text-center">${tableId === 'myTable_History0' ? 'Selected Plat' : tableId === 'myTable_History1' ? 'Overlying of Selected Plat' : 'Underlying of Selected Plat' }</h5>
            <div class="p-4 table-responsive">
                <table id="${tableId}" class="table table-bordered nowrap" style="width: 100%;">
                    <thead>
                        <tr>
                            <th></th>
                            <th>Book</th>
                            <th>Page</th>
                            <th>S.Map #</th>
                            <th>Doc #</th>
                            <th>Sub-Name</th>
                            <th>Block</th>
                            <th>Lot</th>
                            <th>Comments</th>
                            <th>Vacated Status</th>
                            <th>Vacated Date</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr>
                            <td colspan="11" class="text-center">No Records found</td>
                        </tr>
                    </tbody>
                </table>
            </div>`;
}

var selectedRows = [];
var existingRows = [];
var is_str = false;
var add_to_underlying = [];
var add_to_overlying = [];
var str_ids = [];
var row = [];

function updateDataTable(targetDataTable, isUnderlying) {
    if (isUnderlying) {
        is_str = false;
        add_to_underlying = [];
    } else {
        add_to_overlying = [];
    }
    selectedRows.forEach(function(selectedId) {
    var selectedRowData = response.find(function(row) {
      return row.id == selectedId;
    });
    if (selectedRowData && !existingRows.includes(selectedId)) {
        if (isUnderlying) {
            if(selectedRowData.plat_types.type != 'PLAT') {
                $('#submitcombine').hide();
            }
            row = [
                '&nbsp;&nbsp;&nbsp;&nbsp;<button type="button" class="btn btn-info btn-sm text-white removebtn pb-0 pt-0 pr-1 pl-1 removeprop" onclick="removeUnderlyingRow(this,'+ selectedRowData.id+')">x</button>',
                selectedRowData.block,
                selectedRowData.lot,
                selectedRowData.apn_no,
                selectedRowData.plat_types.type,
                selectedRowData.date ? moment(selectedRowData.date).format('MM/DD/YYYY') || '' : ''
            ];
            add_to_underlying.push(selectedId);
        } else {
            row = [
                '&nbsp;&nbsp;&nbsp;&nbsp;<button type="button" class="btn btn-info btn-sm text-white removebtn pb-0 pt-0 pr-1 pl-1 removeprop" onclick="removeOverlyingRow(this,'+ selectedRowData.id+')">x</button>',
                selectedRowData.block,
                selectedRowData.lot,
                selectedRowData.apn_no,
                selectedRowData.plat_types.type,
                selectedRowData.date ? moment(selectedRowData.date).format('MM/DD/YYYY') || '' : ''
            ];
            add_to_overlying.push(selectedId);
        }
        var addedRow = targetDataTable.row.add(row).node(); // Get the DOM node of the added row
        $(addedRow).attr('data-id', selectedId); // Set the data-id attribute to store the row ID
        targetDataTable.draw();
        existingRows.push(selectedId);

        if (isUnderlying) {
            // Update the "Underlying" fields and spans
            $('#underlying_book').text(selectedRowData.subdivisions.map_book);
            $('#underlying_page').text(selectedRowData.subdivisions.map_page);
            $('#underlying_recDate').text(selectedRowData.subdivisions.recording_date);
            $('#underlying_sMap').text(selectedRowData.subdivisions.map_no);
            $('#underlying_doc').text(selectedRowData.subdivisions.document_no);
            $('#underlying_subName').text(selectedRowData.subdivisions.subdivision_name);
            $('#block_lot_type_option').prop('disabled', false);
            $('#replat_date').prop('disabled', false);
            $('#addToOverlyingBtn').prop('disabled', false);
            $("#block_lot_type_option").val(selectedRowData.type);
            $("#replat_date").val(selectedRowData.date);
        } else {
            // Update the "Overlying" fields and spans
            $('#overlying_book').text(selectedRowData.subdivisions.map_book);
            $('#overlying_page').text(selectedRowData.subdivisions.map_page);
            $('#overlying_recDate').text(selectedRowData.subdivisions.recording_date);
            $('#overlying_sMap').text(selectedRowData.subdivisions.map_no);
            $('#overlying_doc').text(selectedRowData.subdivisions.document_no);
            $('#overlying_subName').text(selectedRowData.subdivisions.subdivision_name);
        }
    }
  });
  selectedRows = [];
}

function updateDataTable_str(targetDataTable, isUnderlying) {
    is_str = true;
    add_to_underlying = [];
    selectedRows.forEach(function (selectedId) {
        var selectedRowData = response.find(function(row) {
            return row.id == selectedId;
        });
        if (selectedRowData && !existingRows.includes(selectedId)) {
            if(selectedRowData.plat_types.type != 'PLAT') {
                $('#submitcombine').hide();
            }

            row = [
                '&nbsp;&nbsp;&nbsp;&nbsp;<button type="button" class="btn btn-info btn-sm text-white removebtn pb-0 pt-0 pr-1 pl-1 removeprop" onclick="removeUnderlyingStrRow(this,'+ selectedRowData.id+')">x</button>',
                selectedRowData.section,
                selectedRowData.township,
                selectedRowData.range,
                selectedRowData.quarter,
                selectedRowData.plat_types.type,
                selectedRowData.date ? moment(selectedRowData.date).format('MM/DD/YYYY') || '' : ''
            ];
            add_to_underlying.push(selectedId);
            var addedRow = targetDataTable.row.add(row).node(); // Get the DOM node of the added row
            $(addedRow).attr('data-id', selectedId); // Set the data-id attribute to store the row ID
            targetDataTable.draw();
            existingRows.push(selectedId);

            if (isUnderlying) {
                $('#block_lot_type_option').prop('disabled', false);
                $('#block_lot_type_option option[value="2"]').prop('disabled', true);
                $("#block_lot_type_option").val(3);
                $('#replat_date').prop('disabled', false);
                $('#addToOverlyingBtn').prop('disabled', false);
                $("#replat_date").val(selectedRowData.date);
            } else {
                // Update the "Overlying" fields and spans
                $('#overlying_book').text(selectedRowData.subdivisions.map_book);
                $('#overlying_page').text(selectedRowData.subdivisions.map_page);
                $('#overlying_recDate').text(selectedRowData.subdivisions.recording_date);
                $('#overlying_sMap').text(selectedRowData.subdivisions.map_no);
                $('#overlying_doc').text(selectedRowData.subdivisions.document_no);
                $('#overlying_subName').text(selectedRowData.subdivisions.subdivision_name);
            }

            $('#myTownship').modal('hide');
        }
    });
    selectedRows = [];
}


$('#addToUnderlyingBtn_str').click(function() {

    var underlyingTableStr = document.getElementById("underlyingTable_str");
    underlyingTableStr.classList.remove("d-none");

    // Add the "d-none" class to an element with ID "underlyingTable"
    var underlyingTable = document.getElementById("underlyingTable");
    underlyingTable.classList.add("d-none");

    var checkedBoxes = $('#myTownshipTable tbody input[type="checkbox"].fetchButton:checked');
    selectedRows = [];
    checkedBoxes.each(function() {
        var selectedId = $(this).val();
        selectedRows.push(selectedId);
    });
    // $('#underlyingTable_str').DataTable().clear().draw();
    if ($.fn.DataTable.isDataTable('#underlyingTable_str')) {
        // Destroy the existing DataTable
        $('#underlyingTable_str').DataTable().destroy();
    }
    // $('#overlyingTable').DataTable().clear().draw();
    $('#underlying_book').text('');
    $('#underlying_page').text('');
    $('#underlying_recDate').text('');
    $('#underlying_sMap').text('');
    $('#underlying_doc').text('');
    $('#underlying_subName').text('');
    $("#block_lot_type_option").val('');
    $('#block_lot_type_option').prop('disabled', true);
    $("#replat_date").val('');
    $('#replat_date').prop('disabled', true);
    $('#overlyingTable').DataTable().clear().draw();
    $('#overlying_book').text('');
    $('#overlying_page').text('');
    $('#overlying_recDate').text('');
    $('#overlying_sMap').text('');
    $('#overlying_doc').text('');
    $('#overlying_subName').text('');

    // if (selectedRows.length > 1) {
    //     // Show a warning if more than one row is selected for "Add to Underlying."
    //     new PNotify({
    //         text: 'You can only add one row to Underlying at a time.',
    //         type: 'warning',
    //         delay: 500
    //     });
    // } else {
    // Update the "Underlying" DataTable.

    updateDataTable_str($('#underlyingTable_str').DataTable({
                responsive: true,
                searching: false,
                lengthChange: false,
                lengthMenu: [10,50,100,500,1000],
                info: false,
                autoWidth: false,
                paging: false}), true);

    if (add_to_underlying.length > 0) {
        var data = {
            underlying_block_lot_id: add_to_underlying[0],
            _token: "<?php echo e(csrf_token()); ?>",
            is_str: true
        };

        $.ajax({
            type: 'POST',
            url: "<?php echo e(url('/viewSubdivisionBridge')); ?>",
            data: data,
            success: function (data3) {
                // Show button
                response6 = data3.overlyingPlats;
                response7 = data3.historyData;
                response8 = data3.underlyingPlats;

                //overlying Table
                if (data3.hasOwnProperty('overlyingPlats') && data3.overlyingPlats && data3.overlyingPlats.length > 0) {
                    if ($.fn.DataTable.isDataTable('#overlyingTable')) {
                        // Destroy the existing DataTable
                        $('#overlyingTable').DataTable().destroy();
                    }
                    // Initialize DataTable with JSON response data
                    var dataTable = $('#overlyingTable').DataTable({
                        data: response6,
                        responsive: true,
                        searching: false,
                        lengthChange: false,
                        info: false,
                        paging: false,
                        autoWidth: false,
                        columns: [
                            {
                                data: null,
                                render: function (data, type, row) {
                                    return '&nbsp;&nbsp;&nbsp;&nbsp;<button type="button" class="btn btn-danger btn-sm text-white removebtn pb-0 pt-0 pr-1 pl-1 removeprop" onclick="removeOverlyingRow(this,'+ row.id+')">x</button>';
                                }
                            },
                            { data: 'block' },
                            { data: 'lot' },
                            { data: 'apn_no' },
                            { data: 'plat_types.type' },
                            {
                                data: 'date',
                                render: function (data) {
                                    if (data === null) {
                                        return "";
                                    } else {
                                        return moment(data).format('MM/DD/YYYY');
                                    }
                                }
                            },
                        ],
                        createdRow: function (row, data, dataIndex) {
                            // Set the data-id attribute on the row element
                            $(row).attr('data-id', data.id);
                        }
                    });
                    $('#overlying_book').text(response6[0].subdivisions.map_book);
                    $('#overlying_page').text(response6[0].subdivisions.map_page);
                    $('#overlying_recDate').text(response6[0].subdivisions.recording_date);
                    $('#overlying_sMap').text(response6[0].subdivisions.map_no);
                    $('#overlying_doc').text(response6[0].subdivisions.document_no);
                    $('#overlying_subName').text(response6[0].subdivisions.subdivision_name);
                } else {
                    $('#overlyingTable').DataTable().clear().draw();
                    $('#overlying_book').text('');
                    $('#overlying_page').text('');
                    $('#overlying_recDate').text('');
                    $('#overlying_sMap').text('');
                    $('#overlying_doc').text('');
                    $('#overlying_subName').text('');
                }

                //underlying Table
                if (data3.hasOwnProperty('underlyingPlats') && data3.underlyingPlats && data3.underlyingPlats.length > 0) {
                    if ($.fn.DataTable.isDataTable('#underlyingTable_str')) {
                        // Destroy the existing DataTable
                        $('#underlyingTable_str').DataTable().destroy();
                    }
                    // Initialize DataTable with JSON response data
                    var dataTable = $('#underlyingTable_str').DataTable({
                        data: response8,
                        responsive: true,
                        searching: false,
                        lengthChange: false,
                        info: false,
                        paging: false,
                        autoWidth: false,
                        columns: [
                            {
                                data: null,
                                render: function (data, type, row) {
                                    return '&nbsp;&nbsp;&nbsp;&nbsp;<button type="button" class="btn btn-danger btn-sm text-white removebtn pb-0 pt-0 pr-1 pl-1 removeprop" onclick="removeUnderlyingStrRow(this,'+ row.id+')">x</button>';
                                }
                            },
                            { data: 'section' },
                            { data: 'township' },
                            { data: 'range' },
                            { data: 'quarter' },
                            { data: 'plat_types.type' },
                            {
                                data: 'vacated_date',
                                render: function (data) {
                                    if (data === null) {
                                        return "";
                                    } else {
                                        return moment(data).format('MM/DD/YYYY');
                                    }
                                }
                            },
                        ],
                        createdRow: function (row, data, dataIndex) {
                            // Set the data-id attribute on the row element
                            $(row).attr('data-id', data.id);
                        }
                    });
                    $('#underlying_book').text('');
                    $('#underlying_page').text('');
                    $('#underlying_recDate').text('');
                    $('#underlying_sMap').text('');
                    $('#underlying_doc').text('');
                    $('#underlying_subName').text('');
                } else {
                    $('#underlyingTable').DataTable().clear().draw();
                    $('#underlying_book').text('');
                    $('#underlying_page').text('');
                    $('#underlying_recDate').text('');
                    $('#underlying_sMap').text('');
                    $('#underlying_doc').text('');
                    $('#underlying_subName').text('');
                }
            }
        });
    }
    $('#myPlat').modal('hide');
});


$('#addToUnderlyingBtn').click(function() {

    var underlyingTableStr = document.getElementById("underlyingTable_str");
    underlyingTableStr.classList.add("d-none");

    // Add the "d-none" class to an element with ID "underlyingTable"
    var underlyingTable = document.getElementById("underlyingTable");
    underlyingTable.classList.remove("d-none");

    var checkedBoxes = $('#myPlotTable tbody input[type="checkbox"].fetchButton:checked');
    selectedRows = [];
    checkedBoxes.each(function() {
        var selectedId = $(this).val();
        selectedRows.push(selectedId);
    });
    // $('#underlyingTable').DataTable().clear().draw();
    if ($.fn.DataTable.isDataTable('#underlyingTable')) {
        // Destroy the existing DataTable
        $('#underlyingTable').DataTable().destroy();
    }
    $('#overlyingTable').DataTable().clear().draw();
    $('#underlying_book').text('');
    $('#underlying_page').text('');
    $('#underlying_recDate').text('');
    $('#underlying_sMap').text('');
    $('#underlying_doc').text('');
    $('#underlying_subName').text('');
    $("#block_lot_type_option").val('');
    $('#block_lot_type_option').prop('disabled', true);
    $("#replat_date").val('');
    $('#replat_date').prop('disabled', true);
    $('#overlyingTable').DataTable().clear().draw();
    $('#overlying_book').text('');
    $('#overlying_page').text('');
    $('#overlying_recDate').text('');
    $('#overlying_sMap').text('');
    $('#overlying_doc').text('');
    $('#overlying_subName').text('');

    // if (selectedRows.length > 1) {
    //     // Show a warning if more than one row is selected for "Add to Underlying."
    //     new PNotify({
    //         text: 'You can only add one row to Underlying at a time.',
    //         type: 'warning',
    //         delay: 500
    //     });
    // } else {
    // Update the "Underlying" DataTable.
    updateDataTable($('#underlyingTable').DataTable({
                responsive: true,
                searching: false,
                lengthChange: false,
                lengthMenu: [10,50,100,500,1000],
                info: false,
                autoWidth: false,
                paging: false}), true);

    if (add_to_underlying.length > 0) {
        var data = {
                underlying_block_lot_id: add_to_underlying,
                _token: "<?php echo e(csrf_token()); ?>"
            };

        $.ajax({
            type: 'POST',
            url: "<?php echo e(url('/viewSubdivisionBridge')); ?>",
            data: data,
            success: function (data2) {
                // Show button
                var button = document.getElementById('show-history');
                button.classList.remove('d-none');

                response2 = data2.overlyingPlats;
                response3 = data2.historyData_0;
                response4 = data2.underlyingPlats;
                response5 = data2.historyData_1;
                //overlying Table
                if (data2.hasOwnProperty('overlyingPlats') && data2.overlyingPlats && data2.overlyingPlats.length > 0) {
                    if ($.fn.DataTable.isDataTable('#overlyingTable')) {
                        // Destroy the existing DataTable
                        $('#overlyingTable').DataTable().destroy();
                    }
                    // Initialize DataTable with JSON response data
                    var dataTable = $('#overlyingTable').DataTable({
                        data: response2,
                        responsive: true,
                        searching: false,
                        lengthChange: false,
                        info: false,
                        paging: false,
                        autoWidth: false,
                        columns: [
                            {
                                data: null,
                                render: function (data, type, row) {
                                    return '&nbsp;&nbsp;&nbsp;&nbsp;<button type="button" class="btn btn-danger btn-sm text-white removebtn pb-0 pt-0 pr-1 pl-1 removeprop" onclick="removeOverlyingRow(this,'+ row.id+')">x</button>';
                                }
                            },
                            { data: 'block' },
                            { data: 'lot' },
                            { data: 'apn_no' },
                            { data: 'plat_types.type' },
                            {
                                data: 'date',
                                render: function (data) {
                                    if (data === null) {
                                        return "";
                                    } else {
                                        return moment(data).format('MM/DD/YYYY');
                                    }
                                }
                            },
                        ],
                        createdRow: function (row, data, dataIndex) {
                            // Set the data-id attribute on the row element
                            $(row).attr('data-id', data.id);
                        }
                    });
                    $('#overlying_book').text(response2[0].subdivisions.map_book);
                    $('#overlying_page').text(response2[0].subdivisions.map_page);
                    $('#overlying_recDate').text(response2[0].subdivisions.recording_date);
                    $('#overlying_sMap').text(response2[0].subdivisions.map_no);
                    $('#overlying_doc').text(response2[0].subdivisions.document_no);
                    $('#overlying_subName').text(response2[0].subdivisions.subdivision_name);
                } else {
                    $('#overlyingTable').DataTable().clear().draw();
                    $('#overlying_book').text('');
                    $('#overlying_page').text('');
                    $('#overlying_recDate').text('');
                    $('#overlying_sMap').text('');
                    $('#overlying_doc').text('');
                    $('#overlying_subName').text('');
                }

                //underlying Table
                if (data2.hasOwnProperty('underlyingPlats') && data2.underlyingPlats && data2.underlyingPlats.length > 0) {
                    if ($.fn.DataTable.isDataTable('#underlyingTable')) {
                        // Destroy the existing DataTable
                        $('#underlyingTable').DataTable().destroy();
                    }
                    // Initialize DataTable with JSON response data
                    var dataTable = $('#underlyingTable').DataTable({
                        data: response4,
                        responsive: true,
                        searching: false,
                        lengthChange: false,
                        info: false,
                        paging: false,
                        autoWidth: false,
                        columns: [
                            {
                                data: null,
                                render: function (data, type, row) {
                                    return '&nbsp;&nbsp;&nbsp;&nbsp;<button type="button" class="btn btn-danger btn-sm text-white removebtn pb-0 pt-0 pr-1 pl-1 removeprop" onclick="removeUnderlyingRow(this,'+ row.id+')">x</button>';
                                }
                            },
                            { data: 'block' },
                            { data: 'lot' },
                            { data: 'apn_no' },
                            { data: 'plat_types.type' },
                            {
                                data: 'date',
                                render: function (data) {
                                    if (data === null) {
                                        return "";
                                    } else {
                                        return moment(data).format('MM/DD/YYYY');
                                    }
                                }
                            },
                        ],
                        createdRow: function (row, data, dataIndex) {
                            // Set the data-id attribute on the row element
                            $(row).attr('data-id', data.id);
                        }
                    });
                    $('#underlying_book').text(response4[0].subdivisions.map_book);
                    $('#underlying_page').text(response4[0].subdivisions.map_page);
                    $('#underlying_recDate').text(response4[0].subdivisions.recording_date);
                    $('#underlying_sMap').text(response4[0].subdivisions.map_no);
                    $('#underlying_doc').text(response4[0].subdivisions.document_no);
                    $('#underlying_subName').text(response4[0].subdivisions.subdivision_name);
                }

                // Show History
                // if (data2.hasOwnProperty('historyData_0') && data2.historyData_0 && data2.historyData_0.length > 0) {
                // // Clear existing data and create a new table for each row
                // var modalBody = $("#myHistory .modal-body");
                // modalBody.empty(); // Clear existing data
                // var no_of_table = 0;
                // var header_count = 0;
                // var tablesInRow = 0;
                // var tableRow = $("<div>", {
                //     class: "d-flex flex-row"
                // });
                // var selected_table = false;
                // var currentUid = null;
                // var selected_uid = null;

                // $.each(response3, function (index, row) {
                //     var uid = row.subdivisions.id;
                //     // Create a new table element for each row
                //     no_of_table++;
                //     var newTable = $("<table>", {
                //         class: "table history-table table-bordered mx-3 me-2 mb-2",
                //         style: "width: 30%;"
                //     });

                //     // Create a table header row
                //     // var headerRow = $("<thead>").append("<tr><th>Book</th><th>Page</th><th>S.Map #</th><th>Doc #</th><th>Rec-Date</th><th>Sub-Name</th><th>Block</th><th>Lot</th><th>APN #</th></tr>");
                //     // newTable.append(headerRow);
                //     // var vacatedStatusText = row.is_vacated == 1 ? "Yes" : "No"; // based on the vacated_status value

                //     var vacatedStatusText = row.is_vacated === 1 ? "Yes" : "No"; // Determine the text based on the is_vacated value
                //     if (currentUid !== uid) {
                //         // UID changed, increase table number and create a new table row
                //         header_count++;
                //         currentUid = uid;
                //     }
                //     var temp_count = header_count;

                //     if(add_to_underlying[0] == row.id || selected_uid == uid ) {
                //         header_count = 'Selected PLAT';
                //         selected_uid = uid;
                //         selected_table = true;
                //     }

                //     var bodyRow = $("<tbody>").append(

                //                     "<tr>"+
                //                     "<th class=\"text-center\" colspan=\"2\">" + header_count + "</th>" +
                //                     "</tr>" +

                //                     "<tr>"+
                //                     "<td>Book</td>" +
                //                     "<td>" + (row.subdivisions.map_book || "") + "</td>" +
                //                     "</tr>" +

                //                     "<tr>"+
                //                     "<td>Page</td>" +
                //                     "<td>" + (row.subdivisions.map_page || "") + "</td>" +
                //                     "</tr>" +

                //                     "<tr>"+
                //                     "<td>Map #</td>" +
                //                     "<td>" + (row.subdivisions.map_no || "") + "</td>" +
                //                     "</tr>" +

                //                     "<tr>"+
                //                     "<td>Doc #</td>" +
                //                     "<td>" + (row.subdivisions.document_no || "") + "</td>" +
                //                     "</tr>" +

                //                     "<tr>"+
                //                     "<td>Rec Date</td>" +
                //                     "<td>" + (row.subdivisions.recording_date ? moment(row.subdivisions.recording_date).format('MM/DD/YYYY') : "") + "</td>" +
                //                     "</tr>" +

                //                     "<tr>"+
                //                     "<td>Sub Name</td>" +
                //                     "<td>" + (row.subdivisions.subdivision_name || "") + "</td>" +
                //                     "</tr>" +

                //                     "<tr>"+
                //                     "<td>Block</td>" +
                //                     "<td>" + (row.block || "") + "</td>" +
                //                     "</tr>" +

                //                     "<tr>"+
                //                     "<td>Lot</td>" +
                //                     "<td>" + (row.lot || "") + "</td>" +
                //                     "</tr>" +

                //                     "<tr>"+
                //                     "<td>APN #</td>" +
                //                     "<td>" + (row.apn_no || "") + "</td>" +
                //                     "</tr>"+

                //                     "<tr>"+
                //                     "<td>Vac Type</td>" +
                //                     "<td>" + (row.plat_types.type || "") + "</td>" +
                //                     "</tr>"

                //                     );

                //     newTable.append(bodyRow);
                //     tableRow.append(newTable);
                //     tablesInRow++;
                //     header_count = temp_count;
                //     if(tablesInRow === 3) {

                //         // Reset counter
                //         tablesInRow = 0;

                //         // Append current row
                //         modalBody.append(tableRow);

                //         // Create new row for next set of 3 tables
                //         tableRow = $("<div>", {
                //         class: "d-flex flex-row"
                //         });
                //     }

                // });

                // if(tablesInRow > 0){
                //     modalBody.append(tableRow);
                // }

                // if (data2.hasOwnProperty('historyData_1') && data2.historyData_1 && data2.historyData_1.length > 0) {
                // // Clear existing data and create a new table for each row
                // var modalBody = $("#myHistory .modal-body");
                // // modalBody.empty(); // Clear existing data
                // var no_of_table = 0;
                // var header_count = 0;
                // var tablesInRow = 0;
                // var tableRow = $("<div>", {
                //     class: "d-flex flex-row"
                // });
                // var selected_uid = currentUid;

                // $.each(response5, function (index, row) {
                //     var uid = row.subdivisions.id;
                //     // Create a new table element for each row
                //     no_of_table++;

                //     var newTable = $("<table>", {
                //         class: "table history-table table-bordered mx-3 me-2 mb-2",
                //         style: "width: 30%;"
                //     });

                //     // Create a table header row
                //     // var headerRow = $("<thead>").append("<tr><th>Book</th><th>Page</th><th>S.Map #</th><th>Doc #</th><th>Rec-Date</th><th>Sub-Name</th><th>Block</th><th>Lot</th><th>APN #</th></tr>");
                //     // newTable.append(headerRow);
                //     // var vacatedStatusText = row.is_vacated == 1 ? "Yes" : "No"; // based on the vacated_status value

                //     var vacatedStatusText = row.is_vacated === 1 ? "Yes" : "No"; // Determine the text based on the is_vacated value

                //     if (currentUid !== uid) {
                //         // UID changed, increase table number and create a new table row
                //         header_count++;
                //         currentUid = uid;
                //     }
                //     var temp_count = header_count;

                //     if(add_to_underlying[0] == row.id || selected_uid == uid ) {
                //         header_count = 'Selected PLAT';
                //         selected_uid = uid;
                //         selected_table = true;
                //     }

                //     var bodyRow = $("<tbody>").append(

                //                     "<tr>"+
                //                     "<th class=\"text-center\" colspan=\"2\">" + header_count + "</th>" +
                //                     "</tr>" +

                //                     "<tr>"+
                //                     "<td>Book</td>" +
                //                     "<td>" + (row.subdivisions.map_book || "") + "</td>" +
                //                     "</tr>" +

                //                     "<tr>"+
                //                     "<td>Page</td>" +
                //                     "<td>" + (row.subdivisions.map_page || "") + "</td>" +
                //                     "</tr>" +

                //                     "<tr>"+
                //                     "<td>Map #</td>" +
                //                     "<td>" + (row.subdivisions.map_no || "") + "</td>" +
                //                     "</tr>" +

                //                     "<tr>"+
                //                     "<td>Doc #</td>" +
                //                     "<td>" + (row.subdivisions.document_no || "") + "</td>" +
                //                     "</tr>" +

                //                     "<tr>"+
                //                     "<td>Rec Date</td>" +
                //                     "<td>" + (row.subdivisions.recording_date || "") + "</td>" +
                //                     "</tr>" +

                //                     "<tr>"+
                //                     "<td>Sub Name</td>" +
                //                     "<td>" + (row.subdivisions.subdivision_name || "") + "</td>" +
                //                     "</tr>" +

                //                     "<tr>"+
                //                     "<td>Block</td>" +
                //                     "<td>" + (row.block || "") + "</td>" +
                //                     "</tr>" +

                //                     "<tr>"+
                //                     "<td>Lot</td>" +
                //                     "<td>" + (row.lot || "") + "</td>" +
                //                     "</tr>" +

                //                     "<tr>"+
                //                     "<td>APN #</td>" +
                //                     "<td>" + (row.apn_no || "") + "</td>" +
                //                     "</tr>"+

                //                     "<tr>"+
                //                     "<td>Vac Type</td>" +
                //                     "<td>" + (row.plat_types.type || "") + "</td>" +
                //                     "</tr>"

                //                     );

                //     newTable.append(bodyRow);
                //     tableRow.append(newTable);
                //     tablesInRow++;
                //     header_count = temp_count;
                //     if(tablesInRow === 3) {

                //         // Reset counter
                //         tablesInRow = 0;

                //         // Append current row
                //         modalBody.append(tableRow);

                //         // Create new row for next set of 3 tables
                //         tableRow = $("<div>", {
                //         class: "d-flex flex-row"
                //         });
                //     }

                // });

                // if(tablesInRow > 0){
                //     modalBody.append(tableRow);
                // }

                // }

                // } else {
                //     $("#myTable_History tbody").html("<tr><td colspan='8' class='text-center'>No  found</td></tr>");

                // }
                // if (data2.hasOwnProperty('historyData_0') && data2.historyData_0 && data2.historyData_0.length > 0) {
                //     var historyData = data2.historyData_0; // Assuming you have data in data2.historyData_0
                //     var table = $('#myTable_History0').DataTable({
                //         "destroy": true, // Destroy the existing DataTable instance, if any
                //         "paging": false,
                //         "searching": false,
                //         "ordering": true,
                //         "order": [[4, 'asc'], [5, 'asc'], [6, 'asc']],
                //         "data": historyData,
                //         "columns": [
                //             { "data": "subdivisions.map_book" },
                //             { "data": "subdivisions.map_page" },
                //             { "data": "subdivisions.map_no" },
                //             { "data": "subdivisions.document_no" },
                //             { "data": "subdivisions.subdivision_name" },
                //             { "data": "block" },
                //             { "data": "lot" },
                //             { "data": "comments" },
                //             { "data": "plat_types.type" },
                //             { "data": "date" }
                //         ],
                //         "columnDefs": [
                //             {
                //                 "targets": [6], // Column index for "Vacated Status"
                //                 "orderable": false // Disable sorting for "Vacated Status" column
                //             }
                //         ],
                //         "order": [[0, "asc"]] // Initial sorting by the first column (Book)
                //     });

                //     if (data2.hasOwnProperty('historyData_1') && data2.historyData_1 && data2.historyData_1.length > 0) {
                //         var historyData = data2.historyData_1; // Assuming you have data in data2.historyData_0
                //         var table = $('#myTable_History1').DataTable({
                //             "destroy": true, // Destroy the existing DataTable instance, if any
                //             "paging": false,
                //             "searching": false,
                //             "ordering": true,
                //             "order": [[4, 'asc'], [5, 'asc'], [6, 'asc']],
                //             "data": historyData,
                //             "columns": [
                //                 { "data": "subdivisions.map_book" },
                //                 { "data": "subdivisions.map_page" },
                //                 { "data": "subdivisions.map_no" },
                //                 { "data": "subdivisions.document_no" },
                //                 { "data": "subdivisions.subdivision_name" },
                //                 { "data": "block" },
                //                 { "data": "lot" },
                //                 { "data": "comments" },
                //                 { "data": "plat_types.type" },
                //                 { "data": "date" }
                //             ],
                //             "columnDefs": [
                //                 {
                //                     "targets": [6], // Column index for "Vacated Status"
                //                     "orderable": false // Disable sorting for "Vacated Status" column
                //                 }
                //             ],
                //             "order": [[0, "asc"]] // Initial sorting by the first column (Book)
                //         });
                //     }
                // } else {
                //     $("#myTable_History tbody").html("<tr><td colspan='8' class='text-center'>No records found</td></tr>");
                // }
            }
        });
    }
    $('#myPlat').modal('hide');
});

$('#addToOverlyingBtn').click(function() {
    var underlyingSubName = $('#underlying_subName').text();
    var firstRowSubName = $('#myPlotTable tbody tr:first td:eq(1)').text();
    if((underlyingSubName != '' && underlyingSubName != null && underlyingSubName != undefined) || is_str == true) {
        if ((underlyingSubName !== firstRowSubName) || is_str == true) {
            var checkedBoxes = $('#myPlotTable tbody input[type="checkbox"].fetchButton:checked');
            selectedRows = [];
            checkedBoxes.each(function() {
                var selectedId = $(this).val();
                selectedRows.push(selectedId);
            });
            // $('#overlyingTable').DataTable().clear().draw();
            if ($.fn.DataTable.isDataTable('#overlyingTable')) {
                // Destroy the existing DataTable
                $('#overlyingTable').DataTable().destroy();
            }
            updateDataTable($('#overlyingTable').DataTable({
                responsive: true,
                searching: false,
                lengthChange: false,
                info: false,
                paging: false}), false);
        } else {
            new PNotify({
                text: 'Not allowed to adding Same Subdivision',
                type: 'warning',
                delay: 800
            });
        }
    } else {
        new PNotify({
            text: 'Please add Underlying Property first.',
            type: 'warning',
            delay: 500
        });
    }
    $('#myPlat').modal('hide');
});

$('#submitcombine').click(function() {
   // Initialize arrays to store row IDs
    var underlying_block_lot_ids = [];
    var overlying_block_lot_ids = [];

    // Function to gather row IDs from a DataTable
    function gatherRowIDs(tableId, targetArray) {
        $(tableId + ' tbody tr').each(function() {
            var row = $(this);
            console.log(row.data('id'));
            var rowId = row.data('id'); // Retrieve the row ID stored in data-id attribute
            if (rowId !== undefined) {
                targetArray.push(rowId);
            }
        });
    }

    // Call the function for each DataTable
    gatherRowIDs('#underlyingTable', underlying_block_lot_ids);
    gatherRowIDs('#overlyingTable', overlying_block_lot_ids);
    gatherRowIDs('#underlyingTable_str', underlying_block_lot_ids);

    if(is_str) {
        var data = {
            underlying_block_lot_ids: underlying_block_lot_ids,
            overlying_block_lot_ids: overlying_block_lot_ids,
            block_lot_type_option: $("#block_lot_type_option").val(),
            replat_date: $("#replat_date").val(),
            is_str: is_str,
            _token: "<?php echo e(csrf_token()); ?>"
        };
    } else {
        var data = {
            underlying_block_lot_ids: underlying_block_lot_ids,
            overlying_block_lot_ids: overlying_block_lot_ids,
            block_lot_type_option: $("#block_lot_type_option").val(),
            replat_date: $("#replat_date").val(),
            _token: "<?php echo e(csrf_token()); ?>"
        };
    }

    if (underlying_block_lot_ids.length > 0) {
        $.ajax({
            type: 'POST',
            url: "<?php echo e(url('/mapSubdivisionBridge')); ?>",
            data: data,
            success: function (response) {
                if (response.msg == "Property Maped Successfully!" || response.msg == "Property Map Updated Successfully!") {
                    new PNotify({
                        title: 'Success',
                        text: response.msg,
                        type: 'success',
                        delay: 500
                    });
                    setTimeout(function () {
                        location.reload();
                    }, 500);
                } else if (response.msg == "Property in Overlying is Already Mapped with Another PLAT") {
                    new PNotify({
                        text: response.msg,
                        type: 'warning',
                        delay: 800
                    });
                } else if (response != null && response != undefined) {
                    new PNotify({
                        title: 'Success',
                        text: "Property Type Updated Successfully",
                        type: 'success',
                        delay: 500
                    });
                    setTimeout(function () {
                        location.reload();
                    }, 500);
                } else {
                    new PNotify({
                        text: 'Property Mapping Failed by Unknown Error',
                        type: 'error',
                        delay: 500
                    });
                    return false;
                }
            },
            error: function(error) {
                new PNotify({
                    text: 'Property Mapping Failed by Unknown Error',
                    type: 'error',
                    delay: 500
                });
            }
        });
    } else {
        new PNotify({
            text: 'Please add Underlying Property.',
            type: 'warning',
            delay: 500
        });
    }
});

function showHistroy() {
        $('#myHistory').modal('show');
}

function removeUnderlyingStrRow(button, rowId) {
    var dataTable = $('#underlyingTable_str').DataTable();
    var row = dataTable.row($(button).closest('tr'));
    var rowData = row.data(); // Get the data for the row
    var action = "check";
    if(rowId !== undefined) {
        $.ajax({
            url: '/delete-underlying-str-record',
            type: 'POST',
            data: { id: rowId, action: action, _token: "<?php echo e(csrf_token()); ?>" },
            success: function (response) {
                if (response.exists) {
                    if (userRole == 3) {
                        Swal.fire({
                            title: 'Access Denied',
                            text: 'Only Admins can delete mapped properties.',
                            icon: 'warning',
                        });
                        return;
                    } else {
                        if (action === 'check') {
                            // Record exists, show a confirmation dialog
                            Swal.fire({
                                title: 'Are you sure?',
                                text: 'You are about to delete this record in Database!',
                                icon: 'warning',
                                showCancelButton: true,
                                confirmButtonText: 'Yes, delete it!',
                                cancelButtonText: 'No, cancel',
                            }).then((result) => {
                                if (result.value) {
                                    $.ajax({
                                        url: '/delete-underlying-str-record',
                                        type: 'POST',
                                        data: { id: rowId, action: 'delete', _token: "<?php echo e(csrf_token()); ?>" },
                                        success: function (response) {
                                            if (response.success) {
                                                // Show success message
                                                new PNotify({
                                                    text: "Record deleted Successfully!",
                                                    type: 'success',
                                                    delay: 500
                                                });
                                                setTimeout(function () {
                                                    location.reload();
                                                }, 500);
                                                row.remove().draw();
                                            }
                                        }
                                    });
                                }
                            });
                        }
                    }
                } else {
                    row.remove().draw();
                }
            }
        });
    } else {
        row.remove().draw();
    }
}

function removeUnderlyingRow(button, rowId) {
    var dataTable = $('#underlyingTable').DataTable();
    var row = dataTable.row($(button).closest('tr'));
    var rowData = row.data(); // Get the data for the row
    var action = "check";

    if (rowId !== undefined) {
        $.ajax({
            url: '/delete-underlying-record',
            type: 'POST',
            data: { id: rowId, action: action, _token: "<?php echo e(csrf_token()); ?>" },
            success: function (response) {
                if (response.exists) {
                    if (userRole == 3) {
                        Swal.fire({
                            title: 'Access Denied',
                            text: 'Only Admins can delete mapped properties.',
                            icon: 'warning',
                        });
                        return;
                    } else {
                        if (action === 'check') {
                            // Show a confirmation dialog
                            Swal.fire({
                                title: 'Are you sure?',
                                text: 'You are about to delete this record in Database!',
                                icon: 'warning',
                                showCancelButton: true,
                                confirmButtonText: 'Yes, delete it!',
                                cancelButtonText: 'No, cancel',
                            }).then((result) => {
                                if (result.value) {
                                    // User confirmed, proceed with deletion
                                    $.ajax({
                                        url: '/delete-underlying-record',
                                        type: 'POST',
                                        data: { id: rowId, action: 'delete', _token: "<?php echo e(csrf_token()); ?>" },
                                        success: function (response) {
                                            if (response.success) {
                                                // Show success message
                                                new PNotify({
                                                    text: "Record deleted Successfully!",
                                                    type: 'success',
                                                    delay: 500
                                                });
                                                setTimeout(function () {
                                                    location.reload();
                                                }, 500);
                                                row.remove().draw();
                                            }
                                        }
                                    });
                                }
                            });
                        }
                    }
                } else {
                    // Record doesn't exist, just remove the row
                    row.remove().draw();
                }
            }
        });
    } else {
        // No record ID, just remove the row
        row.remove().draw();
    }
}


function removeOverlyingRow(button, rowId) {
    var dataTable = $('#overlyingTable').DataTable();
    var row = dataTable.row($(button).closest('tr'));
    var rowData = row.data(); // Get the data for the row
    var action = "check";
    if(rowId !== undefined) {
        $.ajax({
            url: '/delete-overlying-record',
            type: 'POST',
            data: { id: rowId, action: action, _token: "<?php echo e(csrf_token()); ?>" },
            success: function (response) {
                if (response.exists) {
                    if (userRole == 3) {
                        Swal.fire({
                            title: 'Access Denied',
                            text: 'Only Admins can delete mapped properties.',
                            icon: 'warning',
                        });
                        return;
                    } else {
                        if (action === 'check') {
                            // Record exists, show a confirmation dialog
                            Swal.fire({
                                title: 'Are you sure?',
                                text: 'You are about to delete this record in Database!',
                                icon: 'warning',
                                showCancelButton: true,
                                confirmButtonText: 'Yes, delete it!',
                                cancelButtonText: 'No, cancel',
                            }).then((result) => {
                                if (result.value) {
                                    $.ajax({
                                        url: '/delete-overlying-record',
                                        type: 'POST',
                                        data: { id: rowId, action: 'delete', _token: "<?php echo e(csrf_token()); ?>" },
                                        success: function (response) {
                                            if (response.success) {
                                                // Show success message
                                                new PNotify({
                                                    text: "Record deleted Successfully!",
                                                    type: 'success',
                                                    delay: 500
                                                });
                                                row.remove().draw();
                                            }
                                        }
                                    });
                                }
                            });
                        }
                    }
                } else {
                    row.remove().draw();
                }
            }
        });
    } else {
        row.remove().draw();
    }
}

</script>
<?php $__env->stopSection(); ?>

<?php echo $__env->make('layouts.app', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH D:\Audit_master\Plant-Audit-Connect\resources\views/app/subdivide_combine/subdivide_combine.blade.php ENDPATH**/ ?>