<?php $__env->startSection('title', 'Property DB | County'); ?>
<?php $__env->startSection('content'); ?>
<style>
    #datatable.dataTable {
        border-collapse: collapse !important;
    }

    tr {
        height: 10px;
    }

    .loaderclass {
        border: 8px solid #f3f3f3;
        border-radius: 50%;
        border-top: 8px solid #3498db;
        width: 60px;
        height: 60px;
        -webkit-animation: spin 1s linear infinite;
        animation: spin 1s linear infinite;
        margin:auto;
        left:0;
        right:0;
        top:0;
        bottom:0;
        position:fixed;
    }

    @-webkit-keyframes spin {
        0% { -webkit-transform: rotate(0deg); }
        100% { -webkit-transform: rotate(360deg); }
    }

    @keyframes spin {
        0% { transform: rotate(0deg); }
        100% { transform: rotate(360deg); }
    }

    #loading-overlay {
        position: fixed;
        width: 100%;
        height:100%;
        left: 0;
        top: 0;
        display: none;
        align-items: center;
        background-color: #000;
        z-index: 999;
        opacity: 0.5;
    }
    .loading-icon{ position:absolute;border-top:2px solid #fff;border-right:2px solid #fff;border-bottom:2px solid #fff;border-left:2px solid #767676;border-radius:25px;width:25px;height:25px;margin:0 auto;position:absolute;left:50%;margin-left:-20px;top:50%;margin-top:-20px;z-index:4;-webkit-animation:spin 1s linear infinite;-moz-animation:spin 1s linear infinite;animation:spin 1s linear infinite;}
    @-moz-keyframes spin { 100% { -moz-transform: rotate(360deg); } }
    @-webkit-keyframes spin { 100% { -webkit-transform: rotate(360deg); } }
    @keyframes spin { 100% { -webkit-transform: rotate(360deg); transform:rotate(360deg); } }

</style>
<div class="container-fluid mt-2">
    <?php echo $__env->make('app.settings.index', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>
    <div class="col-lg-12">
        <div class="card ">
            <div class="card-body">
                <div class="loaderclass"></div>
                <div class="p-0">
                    <table id="datatable" class="table table-bordered nowrap" style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                        <thead>
                            <tr>
                                <th style="width:10%" class="text-center">Sl No</th>
                                <th style="width:10%" class="text-center">Fips Code</th>
                                <th style="width:10%" class="text-center">State Code</th>
                                <th style="width:40%" class="text-center">County Name</th>
                                <th style="width:20%" class="text-center">Status</th>
                            </tr>
                        </thead>
                        <tbody></tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>

<script type="text/javascript">
    $(document).ready(function () {
        $('#datatable').DataTable({
            "preXhr": function () {
                $(".loaderclass").show();
            },
            "drawCallback": function () {
                $(".loaderclass").hide();
            },
            "processing": true,
            "serverSide": true,
            "ajax": {
                "url": "<?php echo e(route('getCountyData')); ?>",
                "type": "POST",
                "headers": {
                    "X-CSRF-TOKEN": "<?php echo e(csrf_token()); ?>"
                },
            },
            rowHeight: 'auto',
            "columns": [{
                    "data": "DT_RowIndex"
                },
                {
                    "data": "fips_code"
                },
                {
                    "data": "state_code"
                },
                {
                    "data": "county_name"
                },
                {
                    "data": "status"
                },
            ],
            responsive: true,
            dom: 'l<"toolbar">Bfrtip',
            buttons: [
                'excel'
            ],
            initComplete: function () {
                // Add any additional initialization code here
            }
        });
    });


    function stateStatus(value) {
        var url = '/countyStatus/' + value;
        var data = {};
        var csrfToken = "<?php echo e(csrf_token()); ?>";

        $.ajax({
            type: 'POST',
            url: url,
            data: data,
            headers: {
                'X-CSRF-Token': csrfToken
            },
            success: function (response) {
                if (response.message == "Status Changed Successfully!") {
                    new PNotify({
                        title: 'Success',
                        delay: 500,
                        text: "Status Changed Successfully!",
                        type: 'success'
                    });
                } else {
                    new PNotify({
                        title: 'Error',
                        text: "An issue has arisen during the update",
                        delay: 800,
                        type: 'error'
                    });
                }
            },
            error: function (error) {
                new PNotify({
                    title: 'Error',
                    text: "An issue has arisen during the update",
                    delay: 800,
                    type: 'error'
                });
            }
        });
    }

</script>
<?php $__env->stopSection(); ?>

<?php echo $__env->make('layouts.app', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH D:\Audit_master\Plant-Audit-Connect\resources\views/app/settings/county.blade.php ENDPATH**/ ?>